/* phomax.h                         tab Oct99..Apr02..Feb03..Oct08  */

#define AmoebaMax 90

#define SpacVersion "Using galexspac version=8.51 (24may11)"

#define SpexVersion "Using galexspex version=8.20 (24may11)"

#define SizeOfHeader 288000       /* Default size of a FITS header in bytes. */

#define MAXSIDE 6100              /* Maximum pixels on a side for an image. */

#define MAXPIX (2*6000*6000)+100  /* Maximum pixels in an image. */
                                  /* about 227 Megabytes for a float array. */

#define BIGMAXPIX (15000*15000)+100 /* Maximum pixels in big image (short). */
                                    /* 15000: 450 Megabytes for short array. */

#define PHOMAX 2000000           /* One million photons (47 MB with phofp). */

#define PHOMAXINTERVAL 200000    /* Maximum photons within each time interval.*/

#define maxCOADD 500             /* Maximum number of coadd (tiles) for 'write_coadd' routine */

#define PhRecMAX 9000            /* Maximum sim. photon records per read. */

#define MOEAMAX 2000             /* Maximum (multi.ord.) effec. area points. */

#define ACEXMAX 2000             /* Maximum number of accumulated exposures. */

#define SLMAX 201000             /* Maximum number of sources (objects). */

#define MSLMAX 160000            /* Maximum number of matched sources. */

#define MAXIMUM_ECLIPSE 60000    /* Used by pipecheck.c and misc.c and galex_webreport.c,  etc... */

#define PDMAXSP 70   /* Maximum number of (Probability Distribution) spectra. */
#define PDMAXPT 500  /* Maximum number of points in spectra. */

#define MCMAX 70     /* Maximum number of points in Mag. Conversion. */

#define MaxBSID 50   /* Maximum number of BSID values (bright source ID, from offset finder, for QA). */

#define NUV_PSSAM 3.20   /* 27jan03: background in pho/sec/square-arcminute. */
#define FUV_PSSAM 0.25

#define NUV_FWHM 5.00   /* 13feb03: Default FWHM values in arcseconds. */
#define FUV_FWHM 5.00   /* 15feb06: changed FUV_FWHM to 5 from 4. */

/* Mission time parameters. */
/* Mission start: 04-28-2003 at 0h UTC */
#define MISSION_START_UNIX 1051488000.0
#define MISSION_START_SCT   735523200.0
#define MISSION_START_JULIAN  2452757.5
#define SIAD 86400.   /* seconds in a day */

/* Count image and plate scale parameters. */
#define DEF_PLTSCL 68.754932   /* arcsec per mm */
#define DEF_CRPIX  1920.5
#define DEF_ASPP   1.50
#define DEF_ASPM   0.068754932   /* arcsec per micron */


/* Readout variance in photon units. */
#define ROVPHU 0.000001

/* Sub-images used in simu.c:simu_RunSpecPhoList(...) */

#define OLD_SIMAXCOL  1402
#define OLD_SIMAXROW   602
#define OLD_SIMAX   844004
#define OLD_PRI_maxpix 844004

/* Used during spac_pao() and ???  #@# */
#define DEF_SIMAXCOL      901     /* GSAX.max_sicol */
#define DEF_SIMAXROW       80     /* GSAX.max_sirow */
#define DEF_SIMAX       72080     /* GSAX.max_sipix */

/* Used during variable extraction width option in galexspac: */
#define SuperMaxRow 200
#define SuperMaxCol 1200

/* For profile model. */
#define PMODmax 300     /* maximum points in profile model */

/* Band limits for spectral band (nuvs and fuvs) computation. */
#define NUVSB_BLUE  1850.
#define NUVSB_RED   2800.
#define NUVSB_CF    1.0254   /* NUV Spectral band correction factor. */
#define FUVSB_BLUE  1350.
#define FUVSB_RED   1750.
#define FUVSB_CF    1.1071   /* FUV Spectral band correction factor. */

/* Spectral Band Split and gap (change gap from 20.0 to 10.0, 26-jun-2007. */
#define BAND_SPLIT 1820.0
#define BAND_SPLIT_GAP 10.0

/* Primary Orders full range of spectral bands. */
/* Note that 1702.5 is set such that (1702.5 - 1300.0) / 3.5 is an integer. */
#define NUV1_WAV1  1702.5   /* 1st order */
#define NUV1_WAV2  3000.
#define FUV2_WAV1  1300.0   /* 2nd order */
#define FUV2_WAV2  1850.

/* Secondary Orders full range of spectral bands. */
/* Note that 1702.5 is set such that (1702.5 - 1300.0) / 3.5 is an integer. */
/* Note that 1401.5 is set such that (1401.5 - 1300.0) / 3.5 is an integer. */
#define NUV2_WAV1  1702.5   /* 2nd order */
#define NUV2_WAV2  2700.
#define FUV3_WAV1  1401.5   /* 3rd order */
#define FUV3_WAV2  1700.

/* Zero-point magnitude. */
/*...........(photons per second)  =  pow(10.,((mag - zpmag)/(-2.5))); ...........  */
/* ...
#define ZPMAG_NUV 20.08238
#define ZPMAG_FUV 18.81707
   ... */
/* Use new Patrick definition of zero point... */
#define ZPMAG_NUV 20.08
#define ZPMAG_FUV 18.82


/* Planck's Constant (ergs x second). */
#define PLANCK 6.626176e-27

/* Planck's Constant x Speed of Light (Angstroms x Ergs). */
#define HC 1.98647759018061e-08

/* Speed of light (km/s). */
#define SOL 299792.458

/* Response Function. */
#define RF_MaxImageSize (4800 * 4800)

/* Pixel scale ratio betw. resp. func. and wavelength-dependent resp. cube. */
#define RW_Coarseness   20

/* Minimum Acceptable Response Value. */
#define Min_Resp_Limit 1.e-10

/* Define the field scale in arcseconds per pixel. */
#define Field_Scale  1.0

/* Limits for RAW6 files. */
#define Raw6_FUV_x1  2960 
#define Raw6_FUV_x2 11675
#define Raw6_FUV_y1  3650
#define Raw6_FUV_y2  9660
#define Raw6_NUV_x1  3500 
#define Raw6_NUV_x2 11040
#define Raw6_NUV_y1  3840
#define Raw6_NUV_y2  8290

/* Default calibration directory. */
#define DefaultCalibrationDirectory "/home/galex/cal/targ/use/"

/* First and last GALEX order in dispersion arrays. */
#define FirstGalexOrder -4
#define LastGalexOrder 5




/* IFD structure (IPAC Float Data).   -tab 08jan2012 */
struct IFDstructure {
  char file[300];    /* Filename for IPAC table float data. */
  char **names;      /* Array of column names. */
  int  nc,nr;        /* Number of columns and rows. */
  float *img;        /* Float Data. */
};
typedef struct IFDstructure IFDtype;

/* IDD structure (IPAC Double Data).   -tab 08jan2012 */
struct IDDstructure {
  char file[300];    /* Filename for IPAC table double data. */
  char **names;      /* Array of column names. */
  int  nc,nr;        /* Number of columns and rows. */
  double *img;       /* Double Data. */
};
typedef struct IDDstructure IDDtype;



/* Grism flat data structure. */
#define MAX_GFLAT 50
#define NC_GFLAT 40
#define NR_GFLAT 40
struct GFLATstructure {
  int num_flat;
  float offset_b1;
  float offset_b2;
  float *image;
};
typedef struct GFLATstructure GFLATtype;


/* Data Release Information. */
#define maxDRI 42000
struct DRIstructure {
  int num;             /* DRI[0].num is number of entries. */
  int kind;            /* 0 = general,  1 = guest investigator,  -1 = unknown. */
  float release;       /* release number. */
  char suffix[20];     /* release suffix label, e.g. '-DIS', '-Spectra-2', etc. */
  int date;            /* Release date, e.g. '20070508' for March 8, 2007. */
  char path[100];      /* Full path of released data. */
};
typedef struct DRIstructure DRItype;


/* Dispersion solution polynomials. */
struct DSPstructure {
  int bandnumber;      /* Band (1=nuv,2=fuv,0=neutral) (DSP[0].bandnumber) */
  int pord;            /* Polynomial solution order. */
  double xoff;         /* Subtract from x value before evaluating polynomial. */
  double coef[99];     /* Polynomial coeffecients. */
  int inv_pord;        /* Inverse Polynomial solution order. */
  double inv_xoff;     /* Subtract from x before eval. inverse polynomial. */
  double inv_coef[99]; /* Inverse Polynomial coeffecients. */
  double off1;         /* Reasonable, nominal lower bound for offset. */
  double off2;         /* Reasonable, nominal upper bound for offset. */
};
typedef struct DSPstructure DSPtype;


/* MODIFIED Full precision photon (48 bytes each) */
struct fullphoton {
  double x;    /* unit sphere coordinates */
  double y;
  double z;
  float  w;    /* wavelength */
  int    m;    /* mask.  if 1, then ignore photon.  if 0, then ok. */
  double t;    /* time */
  double i;    /* ID. */
};
typedef struct fullphoton phofp;   /* PHOton Full Precision */


/* Integer short-precision photon (16 bytes each) */
struct shortphoton {
  short int x;
  short int y;
  short int z;
  short int w;
  long  int t;
  long  int i;
};
typedef struct shortphoton phosp;   /* PHOton Short Precision */


/* Star data structure. */
struct STARstructure {
  unsigned long int id;
  double ra;
  double dec;
  float V;
  float teff;
  float fuv;
  float nuv;
};
typedef struct STARstructure STARtype;


/* ACT Catalog.  4+8+8+(4+4+4+4) = 36 bytes:  (2880 / 36 = 80.0000000)  */
struct ACTstructure {
  int id;           /* AC 2000 Number. */
  double ra;        /* Right Ascension in decimal degrees (J2000). */
  double dec;       /* Declination in decimal degrees (J2000). */
  float raPM;       /* RA proper motion in sec of time/year. */
  float decPM;      /* DEC proper motion in arcsec/year. */
  float VTmag;      /* V magnitude from Tycho. */
  float BmV;        /* Johnson B-V from Tycho. */
};
typedef struct ACTstructure ACTtype;


#define SPDMAXPT 500  /* Maximum number of points in spectra. */
#define SPDMAXSP 90   /* Maximum number of spectra. */

/* Galex spectral Star Probability Distributions for dwarf stars. */
struct SPDstructure {
  int    numsp;          /* Number of spectra ( SPD[0].numsp ) .       */
  double Teff;           /* Effective temperature for Dwarf star.     */
  double ppstot;         /* Total photons per second for V=0.         */
};
typedef struct SPDstructure SPDtype;

/* GALEX grism profile model. */
struct PMODstructure {
  int   numpt;            /* Number of points in array. */
  int   numsource;        /* Number of sources used to construct profile. */
  float fluxfrac;         /* Fraction of flux extracted with nominal objwdith.*/
  float centroid;         /* Centroid of profile model. */
  float fwhm;             /* Rough estimate of FWHM in arcseconds. */
  float peak;             /* Rough estimate of peak in normalized units. */
  float gf_fwhm;          /* Gaussian fit FWHM. */
  float gf_peak;          /* Gaussian fit peak. */
  float nominal_objwidth; /* nominal object width. */
  double xx[PMODmax];     /* x values in arcseconds relative to centroid (<=GSAX.max_sirow). */
  double yy[PMODmax];     /* normalized flux values ( " ). */
  double zz[PMODmax];     /* estimated error in normalized flux values ( " ). */
};
typedef struct PMODstructure PMODtype;


/* Type 1: Expanded photon list (23May00):  11-field/32-byte */
struct EXPHOstructure {
  double     t;        /* Time tag; sec.s since 0Z Jan 1, 1970 ("UNIX time") */
  short int  x,y;      /* Pho. detector pos.*32767(+/-1 full width)(old u,v) */
  unsigned char  val;  /* Scaled photon "value" * 32767 */
  unsigned char    q;  /* Pulse height */
  unsigned short int flags;
  long  int  X,Y,Z;     /* Photon j2k position * 2147483648 */
  short int  thetax;    /* */
  short int  thetay;    /* */
};
typedef struct EXPHOstructure EXPHOtype;


/* Type 2: miller photon list-- 32 bytes */
struct millerphoton {
  unsigned short int  u,v;   /* Photon detector position. */
  unsigned short int  ctl;   /* Control bits. */
  unsigned char      qval;   /* Photon Q "value".  */
  unsigned char        tt;   /* Time-Tag: difference, units of 20 microsec. */
};
typedef struct millerphoton phoml;   /* PHOton Miller List */


/* Type 3: Bin. FITS Photon List: 17-field/48-byte: Full simul. file: may00 */
struct BFPLstructure {
  double        t;            /* time in seconds */
  short int     x;            /* detector x */
  short int     y;            /* detector y */
  unsigned char val;          /* value? */
  unsigned char q;            /* q */ 
  unsigned short int flags;   /* flags? */
  long int      X;            /* unit sphere X */ 
  long int      Y;            /* unit sphere Y */ 
  long int      Z;            /* unit sphere Z */ 
  short int     thetax;       /* theta x */
  short int     thetay;       /* theta y */
  short int     xfp;          /* x focal plane */
  short int     yfp;          /* y focal plane */
  long int      source;       /* source ID */
  short int     tdelay;       /* time delay? */
  unsigned short int lambda;  /* wavelength in Angstroms */
  int           spare;        /* spare? */
};
typedef struct BFPLstructure BFPLtype;


/* Type 4: Abridged Binary FITS Photon List... 5-field/12-byte.  May 2000. */
struct ABFPLstructure {
  short int       X;            /* unit sphere X */ 
  short int       Y;            /* unit sphere Y */ 
  short int       Z;            /* unit sphere Z */ 
  unsigned short int lambda;    /* wavelength in Angstroms. */
  long int       source;        /* source ID */
};
typedef struct ABFPLstructure ABFPLtype;


/* Type 5: Real instr. data Binary FITS Photon List: 3-field/16-byte.  dec00 */
struct RBFPLstructure {
  double          t;         /* time (in seconds?) */
  float        xang;         /* x detector value */
  float        yang;         /* y detector value */ 
};
typedef struct RBFPLstructure RBFPLtype;


/* Type 6: Raw, compressed, 6-byte FITS photon list: 8-field/16-byte. feb01 */
struct RAW6structure {
  double       t;         /* Time tag; sec.s since 0Z 1-1-2000 */
  unsigned char phb1, phb2, phb3, phb4, phb5, phb6;
  unsigned short int flags;
};
typedef struct RAW6structure RAW6type;


/* Star boxes. */
struct SBOXstructure {
  int sc;         /* starting column. */
  int ec;         /* ending column. */
  int sr;         /* starting row. */
  int er;         /* ending row. */
  float xs;       /* x value of star. */
  float ys;       /* y value of star. */
};
typedef struct SBOXstructure SBOXtype;


/* Rotation Matrices. */
struct RMstructure {
  double mat[3][3];        /* Sphere: Normal RA,Dec to prime system. */
  double inv[3][3];        /* Sphere: Prime system to normal RA,Dec. */
  double img[2][2];        /* Image: Normal x,y to "fixed-PA" x,y.  */
  double imginv[2][2];     /* Image: "Fixed-PA" x,y to normal x,y.  */
};
typedef struct RMstructure RMtype;


/*  Image Orientation Parameters 
    ----------------------------
    The transformation from ra,dec to column and row on an image is
    defined by the following.
    (1) Construct 2D rotation matrix "RM.img" from imgPA:
             RM.img[0][0] =-1.*sin( degtorad(imgPA) );
             RM.img[1][0] =-1.*cos( degtorad(imgPA) );
             RM.img[0][1] =    cos( degtorad(imgPA) );
             RM.img[1][1] =-1.*sin( degtorad(imgPA) );
    (2) Use RAo and DECo to set up 3D rotation matrix "RM.mat".
    (3) Use RM.mat to rotate RAc,DECc to primed system: xcp,ycp,zcp).
    (4) Use RM.mat to rotate ra,dec to primed system: xp,yp,zp.
    (5) Translate (offset): x = yp - ycp  and y = zp - zcp.
    (6) Use "RM.img" to rotate x and y.
    (7) The column and row are then:
           column = (x - xmin) / imgscale
           row    = (y - ymin) / imgscale
*/
struct IOPstructure {
  double RAo     ;  /* RA origin gnomonic projection, 3D rotat. matrix. */
  double DECo    ;  /* DEC origin gnomonic projection, 3D rotat. matrix.*/
  double RAc     ;  /* RA center of image in degrees. */
  double DECc    ;  /* DEC center of image in degrees. */
  double xmin    ;  /* x minimum: decimal deg. of 0,0 corner of image. */
  double ymin    ;  /* y minimum: decimal deg. of 0,0 corner of image. */
  double imgscale;  /* degrees per pixel on image (0 if xscale,yscale used). */
  double xscale  ;  /* X scale in degrees per column on image. */
  double yscale  ;  /* Y scale in degrees per row on image. */
  double xsense  ;  /* sense of x image scale: +1 (normal) or -1 (reverse) */
  double ysense  ;  /* sense of y image scale: +1 (normal) or -1 (reverse) */
  double imgPA   ;  /* image Position Angle in degrees. */
  int    sidex   ;  /* number of pixels on x side. */
  int    sidey   ;  /* number of pixels on y side. */
  double crpix1  ;  /* CRPIX1 FITS header parameter. */
  double crpix2  ;
  double cd1_1   ;  /* CD1_1 FITS header parameter. */
  double cd1_2   ;
  double cd2_1   ;
  double cd2_2   ;
  int sixpar     ;  /* If "1" then this is 6 parameter fit. */
};
typedef struct IOPstructure IOPtype;


/* Multiple Order Effective Areas (fractional probabilities). */
struct MOEAstructure {
  int    num;       /* Number of points (MOEA[0].num)                    */
  double wave;      /* wavelengths in Angstroms                          */
  double ea[10];    /* effective area for orders -4,-3,-2,-1,0,1,2,3,4,5 */
  double prob[10];  /* frac. prob. for orders -4,-3,-2,-1,0,1,2,3,4,5    */
};
typedef struct MOEAstructure MOEAtype;



/* Reading and writing MOEA. */
struct RWMstructure {
  float wave;
  float ea[10];
  float extra;
};
typedef struct RWMstructure RWMtype;

/* Reading and writing MOEA with only 2 columns(wavelength and 1st order EA).*/
struct RWM2structure {
  float wave;
  float ea1;
};
typedef struct RWM2structure RWM2type;


/* MCAT QA values */
struct MCQAstructure {
  int  eclipse;           /* Eclipse number. */
  int  tilenum;           /* Tile id number. */ 
  int  visit;             /* Visit number. */
  int  try;               /* try number. */
  float roll;             /* roll angle. */
  char start_time[20];    /* Start time string. */
  char delivery[10][10];  /* delivery strings */
  char type[5];           /* Type, e.g. DIS, MSS, AIS, etc. */
  char OW;                /* Optical Wheel position, e.g. o,d,g, etc. */
  float exptime;          /* Exposure time of this visit. */
  double RAo;             /* Right Ascension of target center. */
  double DECo;            /* Declination of target center. */
  float median_dx;        /* Median DX between merged sources ("). */
  float median_dy;        /* Median DY between merged sources ("). */
  float rms_dx;           /* RMS DX between merged sources. */
  float rms_dy;           /* RMS DX between merged sources. */
  int   filled;           /* number of merged sources. */
  int   N_unfilled;       /* number of unfilled NUV sources. */
  int   F_unfilled;       /* number of unfilled FUV sources. */
  int   pltsol;           /* Plate solution flag. */
  float matang;           /* Median match angle of merged sources. */
  float radsep;           /* Median match radial separation ("). */
  float N_flux;           /* Median log NUV flux. */
  float F_flux;           /* Median log NUV flux. */
  float N_majfwhm;        /* Median NUV major axis FWHM ("). */
  float F_majfwhm;        /* Median FUV major axis FWHM ("). */
  float N_ellip;          /* Median NUV ellipticity (high S/N). */
  float N_majang;         /* Median NUV axis angle (high S/N). */
  float F_majang;         /* Median FUV axis angle (high S/N). */
  float N_phorate;        /* NUV photon rate within 1.05 degrees diameter. */
  float F_phorate;        /* FUV photon rate within 1.05 degrees diameter. */
  float N_ii_mdn;         /* Median of NUV intensity image. */
  float F_ii_mdn;         /* Median of FUV intensity image. */
  char tilename[80];      /* name of tile. */
  float N_ii_mean;        /* Mean of NUV intensity image. */
  float N_ii_rms;         /* RMS of NUV intensity image. */
  float F_ii_mean;        /* Mean of FUV intensity image. */
  float F_ii_rms;         /* RMS of FUV intensity image. */
};
typedef struct MCQAstructure MCQAtype;



/* Galex Simulation Rotated Bright Stars. */
struct RBSstructure {
  double x_xaspp;   /* .x divided by xaspp.  */
  double x_yaspp;   /* .x divided by yaspp.  */
  double y_xaspp;   /* .y divided by xaspp.  */
  double y_yaspp;   /* .y divided by yaspp.  */
};
typedef struct RBSstructure RBStype;


/* Galex Simulation Matched Source List. */
struct MSLstructure {
  int    num;       /* 01 Number of sources (MSL[0].num ).       */
  double tra;       /* 02 Truth RA.                              */
  double tdec;      /* 03 Truth DEC.                             */
  float  tmag;      /* 04 Truth magnitude.                       */
  int    tid;       /* 05 Truth identifier for source.           */
  int    ttype;     /* 06 Truth type.                            */
  double era;       /* 07 Extracted RA.                          */
  double edec;      /* 08 Extracted DEC.                         */
  float  emag;      /* 09 Extracted magnitude.                   */
  int    eid;       /* 10 Extracted identifier for source.       */
  int    etype;     /* 11 Extracted type.                        */
  float  dmag;      /* 12 Delta magnitude.                       */
  float  dpos;      /* 13 Delta position.                        */
  float  error;     /* 14 Error value (goodness of match?)       */
};
typedef struct MSLstructure MSLtype;


/* Eclipse info from chkmps. */
struct cECLstructure {
  int  Eclip;             /* Eclipse number. */
  int  Vsn;               /* Version number? */
  char Type[9];           /* Observation type. */
  char OW[9];             /* Optical Wheel character. */
  int Visit;              /* visit number. */
  double RAo;             /* RA of field center. */
  double DECo;            /* DEC of field center. */
  int PlanID;             /* Planned Tile ID */
  int TileN;              /* Tile Number */
  char Tile[100];         /* Tile (name). */
  int NLegs;              /* Number of legs of visit. */
  char Plan[20];          /* Plan. */
  char Ecl_start[40];     /* eclipse start date */
  char Ecl_end[40];       /* eclipse end date */
  char Delivery[40];      /* chkmps Delivery. */
};
typedef struct cECLstructure cECLtype;


/* Absolute File Statistics. */
struct AFSstructure {
  int  eclipse;             /* Eclipse number. */
  char AbsPipeDir[200];     /* Absolute Pipeline directory. */
  int tilenumber;           /* Tile number from gECL or APD string. */
  char tilename[80];        /* Tile name. */
  char ow;
  int visit;                /* visit number. */
  int try;                  /* Try number from APD. */
  int NLegs;                /* cECL: Number of legs. */
  char Ecl_start[40];       /* cECL: eclipse start time. */
  int Vsn;                  /* cECL: Version number. */
  char Plan[20];            /* cECL: Plan. */
  char Delivery[20];        /* cECL: Delivery. */
  char Type[9];             /* cECL: Type. */
  float exptime;            /* Exposure time. */
  int nexpt;                /* NUV exposure time. */
  int fexpt;                /* FUV exposure time. */
  double ra_cent;           /* RA */
  double dec_cent;          /* DEC */
  double sep;               /* separation between planned and actual RA and DEC */
  double grspa;             /* GRSPA */
  double roll;              /* ROLL */
  double avaspra;           /* Average Aspect RA. */
  double avaspdec;          /* Average Aspect DEC. */
  char grade[20];           /* Grade: PASS, FAIL, UNKNOWN, ... */
  char coadd[20];           /* Coadd status: YES, NO, ... */
  char analyst[20];         /* Analyst ID: NA, tim,tab,min,tas,etc... */
  char mpstype[20];         /* Mission Planning System Type */
  char mpsplan[20];         /* plan */
  char mpsphase[20];        /* phase */
  char grls[200];           /* G-release (software release tag) */
  char redux[200];          /* Reduction date (-xg-gsp.fits or -xd-mcat.fits). */
  int flag;                 /* writing flag. */
  int fileflag[3];          /* File flags for .numfile in TD[] . */
  char disk[20];            /* disk name. */
  char jpegroot[200];       /* jpeg root name (full path). */
  char pslink[200];         /* QA PS file link. */
  char opslink[200];        /* spectral offset QA PS file link. */
  char mpjpglink[200];      /* link to spectral offset median profile GIF file. */
  int LSV;                  /* Largest (successful) subvisit number from -status.txt file.   added -tab 08aug08 */
  int modify;               /* Info modified since previous AFS.dat file? */
  int  unixtime[6];         /* 0: last update of reductions in seconds (largest time) (-1 is not determined) */
                            /* 1: last update of try directory in seconds (-1 if not there). */
                            /* 2: last update of Out.txt in seconds (-1 if not there). */
                            /* 3: last update of -scst.fits file in seconds (-1 if not there). */
                            /* 4: last update of use link or try in seconds (-1 if not there). */
                            /* 5: last update of manual QA file '-qa.txt' (-1 if not there). */
                            /*   unix time == seconds since 1970.  */
};
typedef struct AFSstructure AFStype;

/* COADD string data. */
struct COASstructure {
  char coad[120];    /* coadd directory, e.g. ' /home/hugi3/fltops/pipe/01-vsn/06501-GROTH_00/d/01-main/0001-img/06-try ' */
  char release[10];  /* Release string, e.g. ' GR11.2.1 ' .   */
};
typedef struct COASstructure COAStype;

/* Coadd Table Data. */
struct CTDstructure {
  int ffsecs;
  char tilename[40];
  char ow;
  char Type[9];
  int tilenumber;
  double avaspra;
  double avaspdec;
  int tvis;
  int pyvis;
  int pnvis;
  int cvis;
  int fvis;
  int uvis;
  int bvis;
  float texp;
  float pyexp;
  float pnexp;
  float cexp;
  float fexp;
  float uexp;
  float bexp;
  int lvecl;
  int lcecl;
  char GR_releases[80];
  char GI_releases[80];
  char visit_date[20];     /* reduction date of last 'P Y' eclipse (in eclipse1.tbl). */
  char ff_date[20];        /* final file date (-mcat or -xg-gsp). */
  char coadir[120];
  int cnuv;                /* number of coadded NUV eclipses. */
  int cfuv;                /* number of coadded FUV eclipses. */
  int cnuvecl[maxCOADD];   /* list of coadded NUV eclipses. */
  int cfuvecl[maxCOADD];   /* list of coadded FUV eclipses. */
};
typedef struct CTDstructure CTDtype;



/* Galex Simulation Source List. */
#define MAXusoufile 10
struct SLstructure {
  unsigned long long int ggoid;    /* Galex Global Object ID. */
  unsigned long long int ggoid_D;  /* Direct image Galex Global Object ID. */
  int    num;       /* 01 Number of sources (SL[0].num ).                    */
  int    id;        /* 02 Identifier for source.                             */
  int    id_D;      /* xx Direct ID for source.                              */
  int    band;      /* 03 band(s): 1=nuv only, 2=fuv only, 3=both.           */
  int    type;      /* 04 type of source (1=bright source,0=other).          */
  int    flag;      /* 05 Flag for source  ( 2=extract only, 1=mask only, 
                                             3=extract+mask, 0=nothing)      */
  double ra;        /* 06 Star RA in decimal degrees.                        */
  double dec;       /* 07 Star DEC in decimal degrees.                       */
  float  radius;    /* xx Distance from field center in degrees.             */
  float  Teff;      /* 08 Temperature of source.                             */
  float  Teff_syn;  /* .. Temperature of source for synth.spec.masking.      */
  int    Teff_index;/* .. temperature index for synthetic spectra.           */
  float  fuv;       /* 09 FUV flux of source in photons per second.          */
  float  nuv;       /* 10 NUV flux of source in photons per second.          */
  float  fuverr;    /* 11 FUV flux error of source in photons per second.    */
  float  nuverr;    /* 12 NUV flux error of source in photons per second.    */
  float  fuv_mag;   /*    FUV calibrated AB magnitude.                       */
  float  nuv_mag;   /*    NUV calibrated AB magnitude.                       */
  float  fwhm_spat[2]; /* Spatial FWHM (in arcsec) (nuv and fuv).            */
  float  fwhm_disp[2]; /* Dispersion FWHM (in arcsec) (nuv and fuv).         */
  float  fwhm[2];   /*    FWHM (in arcsec) (nuv and fuv).                    */
  float  major[2];  /*    Major axis FWHM (in arcsec) (nuv and fuv).         */
  float  minor[2];  /*    Minor axis FWHM (in arcsec) (nuv and fuv).         */
  float  theta[2];  /*    Major axis position angle  (nuv and fuv).          */
  float  B;         /*    B magnitude of source.                             */
  float  V;         /*    V magnitude of source.                             */
  float  distrib;   /* 16 Magnitude distribution array.                      */
  float  redshift;  /*    Redshift (Z or Ze).                                */
  float  backgnd[2];/*    Background level in photons/sec/square_arcminute   */
           /* . . . . . extraction stuff . . . . */
  float  objwidth;  /* 17 Object width for extracting source (arcsec)(or -1).*/
  float  bckwidth;  /* 18 Background width for this source (arcsec) (or -1). */
  float  objbcksep; /* 19 Separation between object and background (or -1).  */
  float  arcsec0;   /* 20 undeviated position (arcsec)                       */
  float  arcsec1;   /* 21 blue limit (arcsec)                                */
  float  arcsec2;   /* 22 red limit (arcsec)                                 */
  float  scale;     /* 23 arcseconds per pixel                               */
  int    bckcolrad; /* 24 background columns radius in pixels.               */
           /* . . . . . other stuff . . . . */
  double x;         /* 25 X position of star within grid (degrees).          */
  double y;         /* 26 Y position of star within grid (degrees).          */
  double ape;       /* xx Average position error (arcsecond).                */
  double col;       /* 29 Column value on an image with sub-image PA, scale. */
  double row;       /* 30 Row value on an image with sub-image PA, scale.    */
  double col_oa;    /* .. Column value on an image with Offset Adjustment.   */
  double row_oa;    /* .. Row value on an image with Offset Adjustment.      */
  double det_x;     /* .. Detector X position (in 1.5 arcsec relative pixel) */
  double det_y;     /* .. Detector Y position (in 1.5 arcsec relative pixel) */
  double det_mid_x; /* .. Detector X position (middle of primary order)      */
  double det_mid_y; /* .. Detector Y position (middle of primary order)      */
  double mid_ra;    /* .. RA at position of middle of primary order.         */
  double mid_dec;   /* .. DEC at position of middle of primary order.        */
  float  f;         /* 31 Flux in the current band of choice.                */
  float  fe;        /* 32 Error in flux in the current band of choice.       */
  float  s2n[2];    /* xx Signal to noise in either band.                    */
  float  ps2n[2];   /* xx Predicted S/N flux rate, exposure, etc.(each band) */
  float  ps2n_resel[2]; /* Predicted S/N (from direct flux) per resel. element. */ 
  float  ps2n_pixel[2]; /* Predicted S/N (from direct flux) per 3.5 Ang pixel.  */

  float  magiso[2];        /* MAG_ISO  magnitude from sextractor catalog.    */
  float  magerriso[2];     /* Error.                                         */
/* oct2009
  float  magisocor[2];     /x MAG_ISOCOR  magnitude from sextractor catalog. x/
  float  magerrisocor[2];  /x Error.                                         x/
*/
  float  magaper[2];       /* MAG_APER  magnitude from sextractor catalog.   */
  float  magerraper[2];    /* Error.                                         */
  float  magauto[2];       /* MAG_AUTO  magnitude from sextractor catalog.   */
  float  magerrauto[2];    /* Error.                                         */
  float  magbest[2];       /* MAG_AUTO  magnitude from sextractor catalog.   */
  float  magerrbest[2];    /* Error.                                         */

  int    objtype;   /* Object Type.                                          */
  int    spectype;  /* Spectral type.                                        */
  int    truthid;   /* xx Identifier from truth catalog (best matched source)*/
  int    LXSii;     /* xx LXS[] structure array entry location.              */
  float  truthf;    /* xx Flux from the truth list match.                    */
  float  truthmag;  /* xx Magnitude from truth list match.                   */
           /* . . . . . truth catalog . . . . . */
  int    Tobjtype;  /* Object Type from truth catalog.                       */
  float  Tz;        /* Redshift from truth catalog.                          */
  float  Th;        /* disk scale length from truth catalog.                 */
  float  Tre;       /* bulge effective radius from truth catalog.            */
  float  Tbtr;      /* bulge-to-total ratio from truth catalog.              */
  float  Tpa;       /* Galaxy position angle on the sky from truth catalog.  */
  float  Tincl;     /* Galaxy inclination on the sky from truth catalog.     */
  float  Ttemp;     /* Temperature from truth catalog.                       */
  int    Tspectype; /* Spectral Type from truth catalog.                     */
           /* . . . . . merging . . . . */
  int    oen;       /* original entry number (in full catalog file).         */
  int    candnum;   /* number of candidate matches.                          */
  int    totcandnum;  /* total number of candidate matches.                  */
  int    ambg;      /* ambiguity flag (cleared at -1).                       */
  int    mc;        /* choosen match candidate element number (0 to 8).      */
  int    cand[10];  /* array entry numbers for candidates in other band.     */
  double  prob[10];  /* Probability of match with each candidate.             */
  float  sep[10];   /* Separation between match candidates.                  */
  float  sourcepa;  /* PA between NUV and FUV.                               */
           /* . . . . . post-merging . . . . */
  float nuv_weight; /* effective exposure time at position of source.        */
  float fuv_weight; /* effective exposure time at position of source.        */
  float nuv_int;    /* intensity image value at position of source.          */
  float fuv_int;    /* intensity image value at position of source.          */
  float effmsk;     /* Effective masking (fraction).                         */

  float  E_bv;       /*  E(B-V) Galactic Reddening.                         */
  float  nuv_dfwhm;  /*  NUV FWHM from direct image in arcseconds.          */
  float  fuv_dfwhm;  /*  FUV FWHM from direct image in arcseconds.          */
  int  nuv_artifact; /*  NUV Artifact flag from direct image.               */
  int  fuv_artifact; /*  FUV Artifact flag from direct image.               */
  short  nuv_nc_r2;  /*  NUV neighbor count from direct image within radius R2. */
  short  fuv_nc_r2;  /*  FUV neighbor count from direct image within radius R2. */
  float  nuv_nf_r2;  /*  NUV neighbor flux from direct image within radius R2. */
  float  fuv_nf_r2;  /*  FUV neighbor flux from direct image within radius R2. */
  float  cn_radius;  /*  Closest neighbor radius from direct image (arcsec). */

  int   nuv_ambg;   /* ambiguity. */
  int   fuv_ambg;   /* ambiguity. */
  int   nuv_nc;     /* number of candidates. */
  int   fuv_nc;     /* number of candidates. */
  int   nuv_cid[9]; /* candidate IDs. */
  int   fuv_cid[9]; /* candidate IDs. */
};
typedef struct SLstructure SLtype;


#define RWSLbytes  180
#define RWSLfields 40
#define RWSLblknum 16
/* Read write SL table: 40 fields --180 bytes total (180 x 16 = 2880).        */
struct RWSLstructure {
  int    id;         /* 01 Spectral source ID.                                */
  int    id_D;       /* 02 Direct image source ID.                            */
  unsigned long ggoid[2];   /* 03 Galex global object SPECTRAL ID (2 parts).  */
  unsigned long ggoid_D[2]; /* 04 Galex global object DIRECT ID (2 parts).    */

  int    type;       /* 05 type of source (category).                         */
  int    flag;       /* 06 Flag for source  ( 2=extract only, 1=mask only, 
                                             3=extract+mask, 0=nothing)       */
  int    img_index;  /* 07 Index for image strip file (-pri.fits,-prc.fits).  */
  double ra;         /* 08 Star RA in decimal degrees.                        */
  double dec;        /* 09 Star DEC in decimal degrees.                       */
  float  nuv_mag;    /* 10 Calibrated AB magnitude (NUV) from direct.         */
  float  fuv_mag;    /* 11 Calibrated AB magnitude (FUV) from direct.         */
  float  Teff;       /* 12 Temperature of source.                             */
  float  fuv;        /* 13 FUV flux of source in photons per second.          */
  float  nuv;        /* 14 NUV flux of source in photons per second.          */
  float  fuverr;     /* 15 FUV flux error of source in photons per second.    */
  float  nuverr;     /* 16 NUV flux error of source in photons per second.    */
  float  fwhm;       /* 17 Effective FWHM for this object (in arcsec).        */
  double major;      /* 18 Major axis in arcsec.                              */
  double minor;      /* 19 Minor axis in arcsec.                              */
  float  theta;      /* 20 Major axis to west axis angle +90 to -90,NW(+)SW(-)*/
  float  V;          /* 21 V magnitude of source.                             */

  float  E_bv;       /* 22 E(B-V) Galactic Reddening.                         */
  float  nuv_dfwhm;  /* 23 NUV FWHM from direct image in arcseconds.          */
  float  fuv_dfwhm;  /* 24 FUV FWHM from direct image in arcseconds.          */
  int  nuv_artifact; /* 25 NUV Artifact flag from direct image.               */
  int  fuv_artifact; /* 26 FUV Artifact flag from direct image.               */
  short  nuv_nc_r2;  /* 27 NUV neighbor count from direct image within radius R2. */
  short  fuv_nc_r2;  /* 28 FUV neighbor count from direct image within radius R2. */
  float  nuv_nf_r2;  /* 29 NUV neighbor flux from direct image within radius R2. */
  float  fuv_nf_r2;  /* 30 FUV neighbor flux from direct image within radius R2. */
  float  cn_radius;  /* 31 Closest neighbor radius from direct image (arcsec). */

  float  distrib;    /* 32 Magnitude distribution array.                      */
  float  objwidth;   /* 33 Object width for extracting source (arcsec)(or -1).*/
  float  bckwidth;   /* 34 Background width for this source (arcsec) (or -1). */
  float  objbcksep;  /* 35 Separation between object and background (or -1).  */
  float  arcsec0;    /* 36 undeviated position (arcsec)                       */
  float  arcsec1;    /* 37 blue limit (arcsec)                                */
  float  arcsec2;    /* 38 red limit (arcsec)                                 */
  float  scale;      /* 39 arcseconds per pixel                               */
  int    bckcolrad;  /* 40 background columns radius in pixels.               */
};
typedef struct RWSLstructure RWSLtype;



/* SXSL info structure. */
struct SXSL_INFOstructure {
  int    key;          /* Array entry numbers in SXSL[] to be written out. */
  float  fill_flux;    /* Band-Fill flux. */
  float  fill_fluxerr; /* Band-Fill flux error. */
};
typedef struct SXSL_INFOstructure SXSL_INFOtype;



/* Note that the number of SXSL columns is variable due to the apertures, etc. */
#define maxSXSLcolumns 200

/* Sextractor Extracted Sources List: 84 entries --??? bytes total. */
/* "$" = not in -cat.fits Sextractor output file. */
/* There will be SXSLcolumns in -mcat.fits... there may be a different */
/* number in -cat.fits. */
struct SXSLstructure {

  int    number;           /* Running object number */
  float  flux_iso;         /* Isophotal flux */
  float  fluxerr_iso;      /* RMS error for isophotal flux */
  float  mag_iso;          /* Isophotal magnitude */
  float  magerr_iso;       /* RMS error for isophotal magnitude */
/* oct2009:
  float  flux_isocor;      /x Corrected isophotal flux x/
  float  fluxerr_isocor;   /x RMS error in corrected isophotal flux x/
  float  mag_isocor;       /x Corrected isophotal magnitude x/
  float  magerr_isocor;    /x RMS error for corrected isophotal magnit. x/
*/
  float  flux_aper[33];    /* Flux vector within fixed circular aperture(s) */
  float  fluxerr_aper[33]; /* RMS error vector for aperture flux(es) */
  float  mag_aper[33];     /* Fixed aperture magnitude vector  */
  float  magerr_aper[33];  /* RMS error vector for fixed aperture mag. */
  float  flux_auto;        /* Flux within a Kron-like elliptical aperture */
  float  fluxerr_auto;     /* RMS error for AUTO flux */

/* Not in -mcat.fits table (see BMSL.nuv_fcat_flux,etc. instead) */
  float  flux_oimg;        /* $ Selected flux from other image (?d-?cat.fits).*/
  float  fluxerr_oimg;     /* $ Its error. */

  float  mag_auto;         /* Kron-like elliptical aperture magnitude */
  float  magerr_auto;      /* RMS error for AUTO magnitude */
/* oct2009
  float  flux_best;        /x Best of FLUX_AUTO and FLUX_ISOCOR x/
  float  fluxerr_best;     /x error of flux_best x/
  float  mag_best;         /x Best of MAG_AUTO and MAG_ISOCOR x/
  float  magerr_best;      /x RMS error for MAG_BEST x/
*/
  float  flux_radius[33];  /* Fraction of light radii (new 11feb04) */
  float  zpmag;            /* $ Magnitude zero point correction. */
  float  kron_radius;      /* Kron apertures in units of A or B */
  float  background;       /* Background at centroid position */
  float  threshold;        /* Detection threshold above background */
  float  mu_threshold;     /* Detection threshold above background */
  float  flux_max;         /* Peak flux above background */
  float  mu_max  ;         /* Peak surface brightness above background */
  float  isoarea_image;    /* Isophotal area above Analysis threshold */
  float  isoarea_world;    /* Isophotal area above Analysis threshold */
  float  isoareaf_image;   /* Isophotal area (filtered) above Analysis thresh.*/
  float  isoareaf_world;   /* Isophotal area (filtered) above Analysis thresh.*/

  int    xmin_image;       /* Minimum x-coordinate among detected pixels */
  int    ymin_image;       /* Minimum y-coordinate among detected pixels */
  int    xmax_image;       /* Maximum x-coordinate among detected pixels */
  int    ymax_image;       /* Maximum y-coordinate among detected pixels */
  float  x_image;          /* Object position along x */
  float  y_image;          /* Object position along y */
  int    xpeak_image;      /* x-coordinate of the brightest pixel */
  int    ypeak_image;      /* y-coordinate of the brightest pixel */
  double alpha_j2000;      /* Right ascension of barycenter (J2000) */
  double delta_j2000;      /* Declination of barycenter (J2000) */

  float  x2_image;         /* Variance along x */
  float  y2_image;         /* Variance along y */
  float  xy_image;         /* Covariance between x and y */
  float  x2_world;         /* Variance along X-WORLD (alpha) */
  float  y2_world;         /* Variance along Y-WORLD (delta) */
  float  xy_world;         /* Covariance between X-WORLD and Y-WORLD */
  float  cxx_image;        /* Cxx object ellipse parameter */
  float  cyy_image;        /* Cyy object ellipse parameter */
  float  cxy_image;        /* Cxy object ellipse parameter */
  float  cxx_world;        /* Cxx object ellipse parameter (WORLD units) */
  float  cyy_world;        /* Cyy object ellipse parameter (WORLD units) */
  float  cxy_world;        /* Cxy object ellipse parameter (WORLD units) */
  float  a_image;          /* Profile RMS along major axis */
  float  b_image;          /* Profile RMS along minor axis */
  float  a_world;          /* Profile RMS along major axis (world units) */
  float  b_world;          /* Profile RMS along minor axis (world units) */

  float  theta_image;      /* Position angle (CCW/x) */
  float  theta_world;      /* Position angle (CCW/world-x) */
  float  theta_j2000;      /* Position angle (east of north) (J2000) */
  float  elongation;       /* A_IMAGE/B_IMAGE */
  float  ellipticity;      /* 1 - B_IMAGE/A_IMAGE  */
  double errx2_image;      /* Variance of position along x */
  double erry2_image;      /* Variance of position along y */
  float  errxy_image;      /* Covariance of position between x and y */
  double errx2_world;      /* Variance of position along X-WORLD (alpha) */
  double erry2_world;      /* Variance of position along Y-WORLD (delta) */
  float  errxy_world;      /* Covariance of position X-WORLD/Y-WORLD */

  float  errcxx_image;     /* Cxx error ellipse parameter */
  float  errcyy_image;     /* Cyy error ellipse parameter */
  float  errcxy_image;     /* Cxy error ellipse parameter */
  float  errcxx_world;     /* Cxx error ellipse parameter (WORLD units) */
  float  errcyy_world;     /* Cyy error ellipse parameter (WORLD units) */
  float  errcxy_world;     /* Cxy error ellipse parameter (WORLD units) */
  float  erra_image;       /* RMS position error along major axis */
  float  errb_image;       /* RMS position error along minor axis */
  float  erra_world;       /* World RMS position error along major axis */
  float  errb_world;       /* World RMS position error along minor axis */
  float  errtheta_image;   /* Error ellipse position angle (CCW/x) */
  float  errtheta_world;   /* Error ellipse pos. angle (CCW/world-x) */
  float  errtheta_j2000;   /* J2000 error ellipse pos. angle (east of north) */

  float  fwhm_image;       /* FWHM assuming a gaussian core */
  float  fwhm_world;       /* FWHM assuming a gaussian core (world units) */
  short  flags;            /* Extraction flags. */
  float  class_star;       /* S/G classifier output */
};
typedef struct SXSLstructure SXSLtype;




/* Total number of columns (before SExtractor columns) is 148 (14oct2009...) */
#define maxBMSLcolumns  200
#define BMSLcid 9  /* But only 3 candidate IDs are written as columns. */

/* Band-merged SL table. */
/* as of October 15, 2009: Total -xd-mcat.fits columns = 359 = 
     (lower case columns from BMSL [147]) + (SExtractor columns[106]) + (SExtractor columns[106]). */
/* (NOTE: SExtractor total could be variable for multiple apertures.) */

struct BMSLstructure {

  char   ggoid_hex[17]   ; /*   1:16A: Hex string of GGOID */
  char   ggoid_dec[21]   ; /*   2:20A: Decimal string of GGOID */
  unsigned long ggoid[2] ; /*   3:Galex global object ID (in two parts). */
                           /*   4:vsn     */
                           /*   5:tilenum */
                           /*   6:type    */
                           /*   7:ow      */
                           /*   8:prod    */
                           /*   9:img     */
                           /*  10:try     */
  int    band            ; /*  11:Band number (1=nuv,2=fuv,3=both). */  
  int    id              ; /*  12:ID for merged source (20 bit). */
                           /*  13:subvisit */
                           /*  14:leg      */
  double alpha_j2000     ; /*  15:RA in decimal degrees. */
  double delta_j2000     ; /*  16:DEC in decimal degrees. */
  double alpha_j2000_merged ; /*  Source merged RA in decimal degrees. */
  double delta_j2000_merged ; /*  Source merged DEC in decimal degrees. */
  float  prob            ; /*  19:probability of match. */
  float  sep             ; /*  20:separation of match in arcseconds. */
  float  E_bv            ; /*  21:E(B-V) Galactic Reddening.         */
  float  glon            ; /*  22:Galactic longitude.                */
  float  glat            ; /*  23:Galactic latitude.                 */

  int    primary         ; /*  24:primary source flag. */
  float  fov_radius      ; /* distance from center of FOV in degrees. */
  float  nuv_det_x       ; /* NUV detector X position in pixels (1.5 arcsec) */
  float  nuv_det_y       ; /* NUV detector Y position in pixels  */
  float  fuv_det_x       ; /* FUV detector X position in pixels  */
  float  fuv_det_y       ; /* FUV detector Y position in pixels  */
  int    chkobj_type     ; /* Astrometry check type. */
  int    chkobj_id       ; /* Astrometry check ID. */
  float  chkobj_r        ; /* Astrometry check radius in degrees. */
  float  chkobj_pa       ; /* Astrometry check position angle in degrees. */
  int    misc_flags      ; /* miscellaneous flags. */

  float  nuv_flux        ; /*  35:NUV calibrated flux. */
  float  nuv_fluxerr     ; /* NUV calibrated flux error. */
  float  nuv_mag         ; /* NUV calibrated AB magnitude. */
  float  nuv_magerr      ; /* NUV calibrated AB magnitude error. */
  float  fuv_flux        ; /* FUV calibrated flux. */
  float  fuv_fluxerr     ; /* FUV calibrated flux error. */
  float  fuv_mag         ; /* FUV calibrated AB magnitude. */
  float  fuv_magerr      ; /* FUV calibrated AB magnitude error. */

  float  nuv_s2n         ; /* 43: NUV S/N from default flux value. */
  float  fuv_s2n         ; /* FUV S/N from default flux value. */

  float  nuv_fcat_flux   ; /*  45:NUV calibrated flux from -nd-fcat.fits */
  float  nuv_fcat_fluxerr; /* NUV calibrated flux error. */
  float  fuv_ncat_flux   ; /* FUV calibrated flux from -fd-ncat.fits */
  float  fuv_ncat_fluxerr; /* FUV calibrated flux error. */

  double sep_img         ; /* Separation on images (without adjustment). */

  double fuv_ra_adj             ; /* 49: FUV adjusted RA in degrees. (start of new columns -tab 13oct2009) */
  double fuv_dec_adj            ; /* FUV adjusted DEC in degrees. */
  short  fuv_ncat_flags         ; /* FUV_FLAGS from -fd-ncat.fits */
  float  fuv_ncat_mag           ; /* FUV calibrated magnitude from -fd-ncat.fits */
  float  fuv_ncat_magerr        ; /* error for fuv_ncat_mag */
  float  fuv_ncat_s2n           ; /* FUV signal-to-noise from -fd-ncat.fits */
  float  nuv_fcat_mag           ; /* NUV calibrated magnitude from -nd-fcat.fits */
  float  nuv_fcat_magerr        ; /* error for fuv_ncat_mag */
  float  nuv_fcat_s2n           ; /* NUV signal-to-noise from -nd-fcat.fits */
  float  fuv_ncat_fwhm_image    ; /* FUV FWHM_IMAGE value from -fd-ncat.fits (px) */
  float  fuv_ncat_fwhm_world    ; /* FUV FWHM_WORLD value from -fd-ncat.fits (deg) */
  float  fuv_ncat_flux_radius_1 ; /* 60: FUV FLUX_RADIUS value#1 from -fd-ncat.fits (px) */
  float  fuv_ncat_flux_radius_2 ; /* FUV FLUX_RADIUS value#2 from -fd-ncat.fits (px) */
  float  fuv_ncat_flux_radius_3 ; /* FUV FLUX_RADIUS value#3 from -fd-ncat.fits (px) */
  float  fuv_ncat_flux_radius_4 ; /* FUV FLUX_RADIUS value#4 from -fd-ncat.fits (px) */
  float  fuv_ncat_flux_radius_5 ; /* FUV FLUX_RADIUS value#5 from -fd-ncat.fits (px) */
  float  fuv_ncat_flux_aper_1   ; /* FUV FLUX_APER value#1 from -fd-ncat.fits (cnt/sec) */
  float  fuv_ncat_flux_aper_2   ; /* FUV FLUX_APER value#2 from -fd-ncat.fits (cnt/sec) */
  float  fuv_ncat_flux_aper_3   ; /* FUV FLUX_APER value#3 from -fd-ncat.fits (cnt/sec) */
  float  fuv_ncat_flux_aper_4   ; /* FUV FLUX_APER value#4 from -fd-ncat.fits (cnt/sec) */
  float  fuv_ncat_flux_aper_5   ; /* FUV FLUX_APER value#5 from -fd-ncat.fits (cnt/sec) */
  float  fuv_ncat_flux_aper_6   ; /* 70: FUV FLUX_APER value#6 from -fd-ncat.fits (cnt/sec) */
  float  fuv_ncat_flux_aper_7   ; /* FUV FLUX_APER value#7 from -fd-ncat.fits (cnt/sec) */
  float  fuv_ncat_fluxerr_aper_1; /* error for fuv_ncat_flux_aper_1 */
  float  fuv_ncat_fluxerr_aper_2; /* error for fuv_ncat_flux_aper_2 */
  float  fuv_ncat_fluxerr_aper_3; /* error for fuv_ncat_flux_aper_3 */
  float  fuv_ncat_fluxerr_aper_4; /* error for fuv_ncat_flux_aper_4 */
  float  fuv_ncat_fluxerr_aper_5; /* error for fuv_ncat_flux_aper_5 */
  float  fuv_ncat_fluxerr_aper_6; /* error for fuv_ncat_flux_aper_6 */
  float  fuv_ncat_fluxerr_aper_7; /* error for fuv_ncat_flux_aper_7 */
  float  fuv_ncat_mag_aper_1    ; /* FUV MAG_APER value#1 from -fd-ncat.fits (raw magnitude) */
  float  fuv_ncat_mag_aper_2    ; /* 80: FUV MAG_APER value#2 from -fd-ncat.fits (raw magnitude) */
  float  fuv_ncat_mag_aper_3    ; /* FUV MAG_APER value#3 from -fd-ncat.fits (raw magnitude) */
  float  fuv_ncat_mag_aper_4    ; /* FUV MAG_APER value#4 from -fd-ncat.fits (raw magnitude) */
  float  fuv_ncat_mag_aper_5    ; /* FUV MAG_APER value#5 from -fd-ncat.fits (raw magnitude) */
  float  fuv_ncat_mag_aper_6    ; /* FUV MAG_APER value#6 from -fd-ncat.fits (raw magnitude) */
  float  fuv_ncat_mag_aper_7    ; /* FUV MAG_APER value#7 from -fd-ncat.fits (raw magnitude) */
  float  fuv_ncat_magerr_aper_1 ; /* error for fuv_ncat_magerr_aper_1 */
  float  fuv_ncat_magerr_aper_2 ; /* error for fuv_ncat_magerr_aper_2 */
  float  fuv_ncat_magerr_aper_3 ; /* error for fuv_ncat_magerr_aper_3 */
  float  fuv_ncat_magerr_aper_4 ; /* error for fuv_ncat_magerr_aper_4 */
  float  fuv_ncat_magerr_aper_5 ; /* 90: error for fuv_ncat_magerr_aper_5 */
  float  fuv_ncat_magerr_aper_6 ; /* 91: error for fuv_ncat_magerr_aper_6 */
  float  fuv_ncat_magerr_aper_7 ; /* 92: error for fuv_ncat_magerr_aper_7 (end new cols -tab 13oct2009) */


  short  nuv_nc_r1       ; /*  93:NUV neighbor count out to radius R1 */
  short  nuv_nc_r2       ; /* NUV neighbor count out to radius R2 */
  short  nuv_nc_r3       ; /* NUV neighbor count out to radius R2 */
  short  fuv_nc_r1       ; /* FUV neighbor count out to radius R1 */
  short  fuv_nc_r2       ; /* FUV neighbor count out to radius R2 */
  short  fuv_nc_r3       ; /* FUV neighbor count out to radius R2 */

  float  nuv_nf_r1       ; /*  99:NUV neighbor flux out to radius R1 */
  float  nuv_nf_r2       ; /* NUV neighbor flux out to radius R2 */
  float  nuv_nf_r3       ; /* NUV neighbor flux out to radius R3 */
  float  fuv_nf_r1       ; /* FUV neighbor flux out to radius R1 */
  float  fuv_nf_r2       ; /* FUV neighbor flux out to radius R2 */
  float  fuv_nf_r3       ; /* FUV neighbor flux out to radius R3 */

  float  cn_radius       ; /* 105:Closest neighbor radius in arcseconds.  */
  float  cn_pa           ; /* Closest neighbor position angle in degrees. */
  float  cn_mag_nuv      ; /* Closest neighbor NUV magnitude. */
  float  cn_mag_fuv      ; /* Closest neighbor FUV magnitude. */

  float  nuv_skybg       ; /* 109:NUV true sky backgrnd value at source position. */
  float  fuv_skybg       ; /* FUV true sky backgrnd value at source position. */
  float  nuv_weight      ; /* NUV weight or effective exposure or response.   */
  float  fuv_weight      ; /* FUV weight or effective exposure or response.   */
  float  nuv_int         ; /* NUV intensity image value. */
  float  fuv_int         ; /* FUV intensity image value. */
  float  nuv_thres       ; /* NUV threshold in sigmas: thres = ( int - skybg ) / wt */
  float  fuv_thres       ; /* FUV threshold in sigmas: thres = ( int - skybg ) / wt */
  float  nuv_contrast    ; /* Ratio low pixel to high pixel within extrc box. */
  float  fuv_contrast    ; /*    "                                            */
  float  nuv_scq_mdn     ; /* NUV Q value median within 40 arcsec radius */
  float  nuv_scq_p05     ; /* NUV Q  5th percentile within 40 arcsec radius */
  float  nuv_scq_p95     ; /* NUV Q 95th percentile within 40 arcsec radius */
  float  fuv_scq_mdn     ; /* FUV Q value median within 40 arcsec radius */
  float  fuv_scq_p05     ; /* FUV Q  5th percentile within 40 arcsec radius */
  float  fuv_scq_p95     ; /* FUV Q 95th percentile within 40 arcsec radius */
  short  nuv_maskpix     ; /* Number of masked pixels within extraction box.  */
  short  fuv_maskpix     ; /*    "                                            */
  short  nuv_artifact    ; /* NUV artifact flag. */
  short  fuv_artifact    ; /* FUV artifact flag. */

  float  nuv_scx         ; /* 123: NUV Spacecraft X position. */
  float  nuv_scy         ; /* NUV Spacecraft Y position. */
  float  fuv_scx         ; /* FUV Spacecraft X position. */
  float  fuv_scy         ; /* FUV Spacecraft Y position. */
  float  nuv_Q           ; /* NUV Q value. */
  float  fuv_Q           ; /* FUV Q value. */

  short  nuv_ambg        ; /* 129: NUV ambiguity flag */
  short  fuv_ambg        ; /* 130: FUV ambiguity flag */
  short  nuv_nc          ; /* 131: number of (FUV) candidates for NUV source */
  short  fuv_nc          ; /* 132: number of (NUV) candidates for FUV source */
  int    nuv_cid[BMSLcid]; /* 133,134,135: IDs of top 3 NUV candidates (for FUV source). */
  int    fuv_cid[BMSLcid]; /* 136,137,138: IDs of top 3 FUV candidates (for NUV source). */
  float  nuv_poserr      ; /* 139: NUV field position error (radial,1 sigma). */
  float  fuv_poserr      ; /* 140: FUV field position error (radial,1 sigma). */
  float  ib_poserr       ; /* ...: Interband total field position error. */
  float  nuv_pperr       ; /* 141: NUV Poisson (random) position error (radial,1 sigma). */
  float  fuv_pperr       ; /* 142: FUV Poisson (random) position error (radial,1 sigma). */

                           /* 143: matched_density */
                           /* 144: nuv_unmatched_density */
                           /* 145: fuv_unmatched_density */
  float match_reliability; /* 146: reliabilty */

  float  sourcepa        ; /* 147: position angle between band sources. */

/* DELETE(oct09):  int    objtype      ; object type */
/* DELETE(oct09):  int    quality      ; quality flag (undefined).  */

/* DELETE(oct09):  float  adj_sep      ; 150: {was 106} adjusted separation between merged sources. */
/* DELETE(oct09):  float  adj_fuv_det_y; adjusted FUV detector y position in pixels. */

                           /* BMSLcolumns = ... */
                           /* ...there are 44 new columns. -tab 13oct2009 */
                           /* ...deleted 4 columns. -tab 13oct2009 */

/* Not -mcat.fits columns: */
  float  nuv_ib_poserr   ; /* NUV interband field position error (radial,1 sigma). */
  float  fuv_ib_poserr   ; /* FUV interband field position error (radial,1 sigma). */
  int    nuvSXSL_key     ; /* entry number in NUV Sextractor source list */
  int    fuvSXSL_key     ; /* entry number in FUV Sextractor source list */
  float  fill_flux       ; /* Band-fill flux (either for NUV, FUV or neither. */
  float  fill_fluxerr    ; /* Error in band-fill flux. */
  float  tmp             ; /* temporary values. */
  float  tmp2            ; /* temporary values. */
  float  tmp3            ; /* temporary values. */

  float  xx              ; /* x position on arcsecond gnomonic projection */
  float  yy              ; /* y position on arcsecond gnomonic projection */

};
typedef struct BMSLstructure BMSLtype;



/* runstar.c binary FITS table: 10 fields -- 48 bytes total (48 x 60 = 2880). */
struct RSSLstructure {
  int    number;        /* 01 Source number (starting at 1).          */
  double alpha_j2000;   /* 02 RA of source.                           */
  double delta_j2000;   /* 03 DEC of source.                          */
  float  Teff;          /* 04 Effective temperature.                  */
  float  Vmag;          /* 05 V magnitude                             */
  unsigned long int ID; /* 06 unique source identifier                */
  float  Mag2200;       /* 07 2200 Angstrom magnitude                 */
  float  fuv;           /* 08 GALEX FUV rate                          */
  float  nuv;           /* 09 GALEX NUV rate                          */
  float  radius;        /* 10 Radius from field center in degrees     */
};
typedef struct RSSLstructure RSSLtype;


/* BSB -- bright star box (for pao).                                        */
struct BSBstructure {
  float  cc;      /* Original center column.                 */
  float  cr;      /* Original center row.                    */
  int    sc;      /* Starting column of box.                 */
  int    ec;      /* Ending   column of box.                 */
  int    sr;      /* Starting row of box.                    */
  int    er;      /* Ending   row of box.                    */
};
typedef struct BSBstructure BSBtype;



/* Extracted and synthetic spectra (8 blocks of 2880 bytes). */
#define SBSbytes 23040
#define SBSmaxpt  2873
#define SBSfields   16
struct SBSstructure {
  int numpt;
  int id;
  float nuv;
  float fuv;
  float radius;
  float xcen1;
  float ycen1;
  float fwhm1;
  float bkdf1;
  float residual;
  float weight;
  float xdif1;
  float xrat1;
  float xteff;
  float EXT_Spec[SBSmaxpt];
  float SYN_Spec[SBSmaxpt];
};
typedef struct SBSstructure SBStype;



/* Extracted profile. */
#define PBSbytes 23040
#define PBSmaxpt  2879
#define PBSfields    4
struct PBSstructure {
  int numpt;
  int id;
  float Rel_X[PBSmaxpt];
  float Profile_Flux[PBSmaxpt];
};
typedef struct PBSstructure PBStype;




/* extracted Source Catalog file (fits) Header Cards. */
struct SCHCstructure {
  char   HISTORY[200];
  double EPOCH  ;
  char   OBJECT[200] ;
  char   ORIGIN[200] ;
  double CRVAL1 ;
  double CRVAL2 ;
  double CRPIX1 ;
  double CRPIX2 ;
  double CDELT1 ;
  double CDELT2 ;
  double CROTA1 ;
  double CROTA2 ;
  int    SEXIMASX ;  /*  IMAGE WIDTH (PIXELS) */
  int    SEXIMASY ;  /*  IMAGE HEIGHT (PIXELS) */
  int    SEXSTRSY ;  /*  STRIP HEIGHT (LINES) */
  int    SEXIMABP ;  /*  FITS IMAGE BITPIX */
  double SEXPIXS  ;  /*  PIXEL SCALE (ARCSEC) */
  double SEXSFWHM ;  /*  SEEING FWHM (ARCSEC) */
  char   SEXNNWF[200]  ;  /*  CLASSIFICATION NNW FILENAME */
  double SEXGAIN  ;  /*  GAIN (IN E- PER ADU) */
  double SEXBKGND ;  /*  MEDIAN BACKGROUND (ADU) */
  double SEXBKDEV ;  /*  MEDIAN RMS (ADU) */
  double SEXBKTHD ;  /*  EXTRACTION THRESHOLD (ADU) */
  char   SEXCONFF[200] ;  /*  CONFIGURATION FILENAME */
  char   SEXDETT[200]  ;  /*  DETECTION TYPE */
  char   SEXTHLDT[200] ;  /*  THRESHOLD TYPE */
  double SEXTHLD  ;  /*  THRESHOLD */
  int    SEXMINAR ;  /*  EXTRACTION MINIMUM AREA (PIXELS) */
  short  SEXCONV  ;  /*  CONVOLUTION FLAG */
  short  SEXCONVN ;  /*  CONVOLUTION NORM. FLAG */
  char   SEXCONVF[200] ;  /*  CONVOLUTION FILENAME */
  int    SEXDBLDN ;  /*  NUMBER OF SUB-THRESHOLDS */
  double SEXDBLDC ;  /*  CONTRAST PARAMETER */
  short  SEXCLN   ;  /*  CLEANING FLAG */
  double SEXCLNPA ;  /*  CLEANING PARAMETER */
  int    SEXCLNST ;  /*  CLEANING OBJECT-STACK */
  int    SEXAPERD ;  /*  APERTURE DIAMETER (PIXELS) */
  double SEXAPEK1 ;  /*  KRON PARAMETER */
  double SEXAPEK2 ;  /*  KRON ANALYSIS RADIUS */
  double SEXAPEK3 ;  /*  KRON MINIMUM RADIUS */
  double SEXSATLV ;  /*  SATURATION LEVEL (ADU) */
  double SEXMGZPT ;  /*  MAGNITUDE ZERO-POINT */
  double SEXMGGAM ;  /*  MAGNITUDE GAMMA */
  int    SEXBKGSX ;  /*  BACKGROUND MESH WIDTH (PIXELS) */
  int    SEXBKGSY ;  /*  BACKGROUND MESH HEIGHT (PIXELS) */
  int    SEXBKGFX ;  /*  BACKGROUND FILTER WIDTH */
  int    SEXBKGFY ;  /*  BACKGROUND FILTER HEIGHT */
  char   SEXPBKGT[200] ;  /*  PHOTOM BACKGROUND TYPE */
  int    SEXPBKGS ;  /*  LOCAL AREA THICKNESS (PIXELS) */
  int    SEXPIXSK ;  /*  PIXEL STACKSIZE (PIXELS) */
  int    SEXFBUFS ;  /*  FRAME-BUFFER SIZE (LINES) */
  double SEXISAPR ;  /*  ISO-APER RATIO */
  int    SEXNDET  ;  /*  NB OF DETECTIONS */
  int    SEXNFIN  ;  /*  NB OF FINAL EXTRACTED OBJECTS */
  int    SEXNPARA ;  /*  NB OF PARAMETERS PER OBJECT */
  char   GRELEASE[200]  ;
  char   CTYPE1[200]  ;
  char   CTYPE2[200]  ;
  double EQUINOX ;
  double RA_CENT ;
  double DEC_CENT;
  double TWIST   ;
  int    ECLIPSE ;
  double GRSPA ;
  int    LEG ;
  int    MPSNPOS ;
  int    VISIT ;
  int    SUBVIS ;
  int    MINIVIS ; 
  int    OW ;
  int    BAND ;
  double ROLL ;
  double EXPTIME ;
  double EXPSTART;
  double EXPEND  ;
  char   OBS_DATE[200];   /* card name: OBS-DATE */
  char   TIME_OBS[200];   /* card name: TIME-OBS (was OBS-TIME or OBS_TIME) */
  double OBSSECS ;
  char   OBSDATIM[200];
  char   TILENAME[200];
  int    TILENUM ;
  int    PLANID ;
  char   MPSPHASE[200];
  char   MPSPLAN[200];
  char   MPSTYPE[200];
  int    IMAGSZX ;
  int    IMAGSZY ;
  double AVASPRA ;
  double AVASPDEC ;
  double AVASPX ;
  double AVASPY ;
  double AVASPROL ;
  double AVASPOK  ;
  char   CALPATH[200];
  char   FLATFL[200];
  char   INTIMAGE[200];
  char   PHOFILE[200];
  int    NVALIDPH;
  int    FILTERED;
  double PSFFWHM; 
  double CONVFWHM;
  double POISBG;
  int    TEDMODE;  
  double SXAPER[33];
  double SXFRAC[33];
  double SIGTHRESH;
  double ABSTHRESH;

  double SXDBGRMS;
  double AREADET;
  double PSIGDET;
  double PMEDBG;
  double PMEDRR;
  double PTHRBG;
  double PTHRESH;
  double AVEPEFIX;
  double MINPEFIX;
  double MAXPEFIX;
  double AVEPEA;
  double MINPEA;
  double MAXPEA;

  char   SXWD[200];
  double ACOXYAVE; 
  double ACOXYMED; 
  double ACOXYSD; 
  double ACOXYMIN; 
  double ACOXYMAX; 
  char   ABSCAL[200];
  char   CALINFO[200];
  char   STATFILE[200];
  char   ABSPIPE[200];
  char   PRUNDAT0[200];
  char   PRUNDAT1[200];
  char   PIPECMNT[200];
  int    NLEGS;
  char   MPSCOW[200];
  double NHVNOM; 
  double NHVNOMN; 
  double NHVNOMF; 
  double NEXPTIME; 
  double FEXPTIME; 
  int    PIPESTAT;
  char   LONGSTRN[200];
};
typedef struct SCHCstructure SCHCtype;


/* Accumulated Exposures table: 17 fields -- 480 bytes total. */
#define ACEXbytes  480
#define ACEXfields  18
struct ACEXstructure {
  int    num;          /* 01 Number of exposures accumalated (ACEX[0].num).*/
  int    numpho;       /* 02 Number of photons in a given exposure.        */
  int    tilenum;      /* 03 Tile number.                                  */
  short  subvisit;     /* 04 sub-visit number.                             */ 
  short  visit;        /* 05 Visit or image number.                        */ 
  int    eclipse;      /* 06 Eclipse (orbit) number.                       */ 
  char   phofile[178]; /* 07 photon list filename for a given exposure.    */
  char   prifile[178]; /* 08 PRI filename for a given exposure.            */
  char   redux[20];    /* 09 reduction date for a given exposure.          */
  char   obsdatim[20]; /* 10 observation date and time.                    */
  double obssecs;      /* 11 observation date in seconds (unix time).      */
  double roll;         /* 12 Spacecraft roll angle.                        */
  double grspa;        /* 13 Grism position angle (deg) for exposure (fit).*/
  double grspaorg;     /* 14 Original grism position angle in degrees. */
  double exptime;      /* 15 Exposure time in seconds for a given exposure.*/
  double Stwist;       /* 16 Twist (degrees) used for source positions.    */
  double Sxoff;        /* 17 X offset (arcseconds) used for sources.       */
  double Syoff;        /* 18 Y offset (arcseconds) used for sources.       */
};
typedef struct ACEXstructure ACEXtype;


/* Spectral Photon List (translated). */
struct SPLstructure {
  unsigned short int souno;  /* Source number (element number in SL[] array. */
  unsigned short int pixno;  /* Pixel number in sub-image. */
};
typedef struct SPLstructure SPLtype;


/* SHORT INTEGER: Whole Field Photon List (translated). */
struct WFPLstructure {
  unsigned short int x;  /* X direction photon position. */
  unsigned short int y;  /* Y direction photon position. */
};
typedef struct WFPLstructure WFPLtype;


/* FLOAT: Whole Field Photon List (translated). */
struct WFPLFstructure {
  float x;  /* X direction photon position. */
  float y;  /* Y direction photon position. */
};
typedef struct WFPLFstructure WFPLFtype;


/* Parameters for WFPL. */
struct WFPL_PARstructure {
  int  ArrayLimit;   /* Array limit on WFPL[]. */
  int  PhotonLimit;  /* Maximum index of whole photon array to be read in. */
  int  PhotonIncrement;  /* Increment to use when reading in photons. */
  int  numpho;       /* Number of photons actually read into WFPL. */
  double Zero;       /* Zero point for WFPL. */
  double Scale;      /* Scale for WFPL. */
                     /* WFPL.x,.y are given by ix = ((xxp - WFPL_PAR.Zero) / WFPL_PAR.Scale) + 0.5 . */
  int MaxInt;        /* Maximum integer value in WFPL. */
};
typedef struct WFPL_PARstructure WFPL_PARtype;


/* Galex Magnitude Conversion 5550 to 2200. */
struct MCstructure {
  int    num;       /* Number of points ( MC[0].num ). */
  double Teff;      /* Effective temperature. */
  double conv;      /* Conversion factor:  Mag2200 = Vmag + factor  */
};
typedef struct MCstructure MCtype;


/* Extracted Spectrum Data (for one spectrum per file). 32 bytes total. */
/* SXS = Single Extracted Spectrum. */
struct SXSstructure {
  float offset;   /* 1. Offset in arcseconds.               */
  float obj;      /* 2. Object flux in relative data units. */
  float opx;      /* 3. Optimal extraction flux.            */
  float objerr;   /* 4. Object flux error.                  */
  float opxerr;   /* 5. Optimal extraction error.           */
  float wgt;      /* 6. Weighting (or coverage) (average over object width). */
  float bck;      /* 7. Ave. background (average over background regions).   */
  float profile;  /* 8. Profile data.                       */
};
typedef struct SXSstructure SXStype;


/* GalexSpac command-line PARameters. Added. -tab 10nov2008 */
struct GSPARstructure {
  float objwidth;        /* Extracted object width in arcseconds.      */
  float bckwidth;        /* Extracted background width in arcseconds.  */
  float objbcksep;       /* Object-Background separation in arcsec.    */
  float arcsec1;         /* Blue limit relative to undev. wave pt.     */
  float arcsec2;         /* Blue limit relative to undev. wave pt.     */
  int   bckcolrad;       /* Background column radius in pixels.        */
  int   select;          /* Value for '-select' option.                */
  int   select_mask;     /* Value for '-select_mask' option.           */
  int   ClearGrismFlat;  /* if '1' clear grism flats (set to 1.0).     */
  char  source[200];     /* '-mcat' type file for '-source' option.    */
  char  add[200];        /* File of user-added sources.                */
};
typedef struct GSPARstructure GSPARtype;


/* eXtraction PARameters. */
struct XPARstructure {
  float objwidth;        /* Extracted object width in arcseconds.       */
  float bckwidth;        /* Extracted background width in arcseconds.   */
  float objbcksep;       /* Object-Background separation in arcsec.     */
  int   bckcolrad;       /* Background column radius in pixels.         */
};
typedef struct XPARstructure XPARtype;



/* Galex Spectrum Data (for one spectrum per row).           */
/* CHANGED system, no longer needs to be multiples of 2880 -tab 29nov07 */
/* Assumes a range of 1300 to 3000 and 3.5 Angstroms/pixel.  */
#define GSPfields 96
#define GSP_NUMPT 551
#define GSP_NUMPRO 194
struct GSPstructure {

  unsigned long ggoid[2];    /* Galex global object ID (in two parts).       */
  unsigned long ggoid_D[2];  /* Direct image galex global object ID (in two).*/
  int    band;               /* Band number (4 bit).                         */  
  int    id;                 /* Identifier.                                  */

  double ra;              /* Right Ascension in degrees.  (J2000)         */
  double dec;             /* Declination in degrees.      (J2000)     [6] */

  int    nuv_nc;          /* number of columns in image strip. */
  int    nuv_nr;          /* number of rows in image strip. */
  float  nuv_mag;         /* magnitude from direct source catalog. */
  float  nuv_detx;        /* Detector X position of undeviated wavelength point */
  float  nuv_dety;        /* Detector Y position of undeviated wavelength point */
  float  nuv_Q;           /* Q value at undeviated wavelength point. */
  float  nuv_mid_detx;    /* Detector X position of middle of primary order. */
  float  nuv_mid_dety;    /* Detector Y position of middle of primary order. */
  float  nuv_mid_Q;       /* Q value at middle of primary order. */
  double nuv_mid_ra;      /* RA of middle of primary order. */
  double nuv_mid_dec;     /* Declination of middle of primary order.   [17] */

  int    fuv_nc;          /* number of columns in image strip. */
  int    fuv_nr;          /* number of rows in image strip. */
  float  fuv_mag;         /* magnitude from direct source catalog. */
  float  fuv_detx;        /* Detector X position of undeviated wavelength point */
  float  fuv_dety;        /* Detector Y position of undeviated wavelength point */
  float  fuv_Q;           /* Q value at undeviated wavelength point. */
  float  fuv_mid_detx;    /* Detector X position of middle of primary order. */
  float  fuv_mid_dety;    /* Detector Y position of middle of primary order. */
  float  fuv_mid_Q;       /* Q value at middle of primary order. */
  double fuv_mid_ra;      /* RA of middle of primary order. */
  double fuv_mid_dec;     /* Declination of middle of primary order.  [28] */

  int    numpt;           /* Number of points in spectra.                */
  float  objwidth;        /* Extracted object width in arcseconds.       */
  float  bckwidth;        /* Extracted background width in arcseconds.   */
  float  objbcksep;       /* Object-Background separation in arcsec.     */
  int    bckcolrad;       /* Background column radius in pixels.    [33] */

  int    truthid;         /* ID from the Todd's truth list.              */
  int    objtype;         /* Object type (-1=unknown,1=star,0=galaxy)    */
  float  temperature;     /* Estimated temperature in Kelvin (star).     */
  float  redshift;        /* Estimated redshift (galaxy or quasar).      */
  float  slope;           /* Slope of spectrum.                          */
  int    qa;              /* QA value.                                   */
  int    flag;            /* Miscellaneous flag value.              [40] */

          /* Below there are two entries: 0th=NUV, 1st=FUV   */
  float weight[2];         /* Average effective weight with masking (sec).    */
  float background[2];     /* Average background level (nuv and fuv).         */
  float median_s2n[2];     /* Median signal-to-noise per pixel (nuv and fuv). */
  float median_s2n_opx[2]; /* (Optimal Extraction) median signal-to-noise per pixel (nuv and fuv). */
  float centroid[2];       /* Profile centroid (nuv and fuv).                 */ 
  float specfwhm[2];       /* Spectral spatial profile FWHM (nuv and fuv).    */ 
  float effexp[2];         /* Average effec. exposure (response) w/no mask(sec)    */
  float effmsk[2];         /* Average effective masking fraction.                  */
  float effwgt[2];         /* Average effec. exposure in seconds (with mask)  [49] */

  int    nuv_numpro;     /* Number of points in NUV profile.     */
  int    fuv_numpro;     /* Number of points in FUV profile.     */

  float nuv_profile[GSP_NUMPRO]; /* Spatial profile for NUV (arcsec).      */
  float fuv_profile[GSP_NUMPRO]; /* Spatial profile for FUV (arcsec). [53] */

  float nuv;             /* NUV flux (direct image) in photons/second.   */
  float nuve;            /* NUV flux error (direct image).               */
  float fuv;             /* FUV flux (direct image) in photons/second.   */
  float fuve;            /* FUV flux error (direct image).          [57] */

  float  E_bv;           /* E(B-V) Galactic Reddening.                             */
  float  nuv_dfwhm;      /* NUV FWHM from direct image in arcseconds.              */
  float  fuv_dfwhm;      /* FUV FWHM from direct image in arcseconds.              */
  int  nuv_artifact;     /* NUV Artifact flag from direct image.                   */
  int  fuv_artifact;     /* FUV Artifact flag from direct image.                   */
  short  nuv_nc_r2;      /* NUV neighbor count from direct image within radius R2. */
  short  fuv_nc_r2;      /* FUV neighbor count from direct image within radius R2. */
  float  nuv_nf_r2;      /* NUV neighbor flux from direct image within radius R2.  */
  float  fuv_nf_r2;      /* FUV neighbor flux from direct image within radius R2.  */
  float  cn_radius;      /* Closest neighbor radius from direct image (arcsec).  [67] */

  float nuvs;            /* All-orders NUV bandpass flux: 2000-2700(A).         */
  float nuvse;           /* Flux error.                                         */
  float fuvs;            /* All-orders FUV bandpass flux: 1400-1700(A).         */
  float fuvse;           /* Flux error.                                   [71]  */

  float nuvs_opx;        /* (Opt.Extr.) NUV bandpass flux: 2000-2700(A).        */
  float nuvse_opx;       /* Flux error (Opt.Extr.)                              */
  float fuvs_opx;        /* (Opt.Extr.) FUV bandpass flux: 1400-1700(A).        */
  float fuvse_opx;       /* Flux error (Opt.Extr.)                        [75]  */

  float nuv0s;           /* NUV order#0 bandpass flux: -355 to -315(").      */
  float nuv0se;          /* Flux error.                                      */
  float nuv1s;           /* NUV order#1 bandpass flux:    0 to 320(").       */
  float nuv1se;          /* Flux error.                                      */
  float nuv2s;           /* NUV order#2 bandpass flux:  400 to 900(").       */
  float nuv2se;          /* Flux error.                                 [81] */

  float fuv1s;           /* FUV order#1 bandpass flux:  -50 to  25(").       */
  float fuv1se;          /* Flux error.                                      */
  float fuv2s;           /* FUV order#2 bandpass flux:  260 to 390(").       */
  float fuv2se;          /* Flux error.                                      */
  float fuv3s;           /* FUV order#3 bandpass flux:  500 to 750(").       */
  float fuv3se;          /* Flux error.                                 [87] */

  float zero;            /* Wavelength center of first pixel (.obj[0]).      */
  float disp;            /* Linear dispersion in Angstroms per pixel.        */

  float obj[GSP_NUMPT];     /* Flux in photons/sec/Ang/cm^2             [90] */
  float objerr[GSP_NUMPT];  /* Error (1 sigma).                              */
  float opx[GSP_NUMPT];     /* Optimized Flux (pho/sec/Ang/cm^2)             */
  float opxerr[GSP_NUMPT];  /* Optimized Error (1 sigma).                    */
  float objs[GSP_NUMPT];    /* Secondary Flux (NUV 2nd, FUV 3rd order)       */
  float objserr[GSP_NUMPT]; /* Secondary Error.                              */
  float objmdn[GSP_NUMPT];  /* Median image strip spectrum.             [96] */

};
typedef struct GSPstructure GSPtype;



/* Spectral Template Data.  Contains 8640 bytes. */
#define STDfields  8
#define STDbytes   8640
#define STD_NUMPT  539
struct STDstructure {
  int   numpt;           /* Number of points in spectrum.              */
  float ratiobin;        /* ratio bin in log10(nuv/fuv). */
  float range1;          /* range 1 for ratio bin in log10(nuv/fuv). */
  float range2;          /* range 1 for ratio bin in log10(nuv/fuv). */
  float x[STD_NUMPT];    /* wavelengths. */
  float y[STD_NUMPT];    /* flux. */
  float w[STD_NUMPT];    /* weight or polynomial fit. */
  float f[STD_NUMPT];    /* average or final flux. */
};
typedef struct STDstructure STDtype;



/* Data from -xsp.fits file. */
#define XSP_NUMPT 900
struct XSPstructure {
  int   numpt;              /* Number of points in spectrum.                */
  int   id;                 /* ID.                                          */
  float zero;               /* Arcsecond center of first pixel.             */
  float disp;               /* Linear dispersion in Arcseconds per pixel.   */
  float obj[XSP_NUMPT];     /* Photons per second per Arcsecond.            */
  float objerr[XSP_NUMPT];  /* Error.                                       */
  float wgt[XSP_NUMPT];     /* Average weight (seconds) (ave.over object).  */
  float bck[XSP_NUMPT];     /* Average background (over bcckground region). */
};
typedef struct XSPstructure XSPtype;



/* Extracted Spectrum Data (for Binary FITS table spectra). */
/* Bytes should total (40 x 2880 =) 115200. */
struct XSstructure {
  char objname[456];  /* Object name.                         1 */
  int npix;           /* Number of pixels of spectrum data.   2 */
  int id;             /* Source identifier number.            3 */
  int truthid;        /* Truth list source identifier number. 4 */
  double ra;          /* Right Ascension (degrees) (J2000).   5 */ 
  double dec;         /* Declination (degrees) (J2000).       6 */
  float fuv;          /* FUV rate from direct extraction.     7 */
  float nuv;          /* NUV rate from direct extraction.     8 */
  float fuverr;       /* FUV rate error.                      9 */
  float nuverr;       /* NUV rate error.                     10 */
  float Vmag;         /* V magnitude.                        11 */
  float Mag2200;      /* Magnitude at 2200 Angstroms.        12 */
  float Teff;         /* Effective temperature.              13 */
  float lam[4096];    /* Wavelength in Angstroms.            14 */
  float obj[4096];    /* Object flux in relative data units. 15 */
  float opx[4096];    /* Optimal extraction flux.            16 */
  float objerr[4096]; /* Object flux error.                  17 */
  float opxerr[4096]; /* Optimal extraction error.           18 */
  float wgt[4096];    /* Weighting (or coverage) (average).  19 */
  float bck[4096];    /* Average background level.           20 */
};
typedef struct XSstructure XStype;




/* Last Extracted Spectra. */
/* Define .dat[0] to correspond to -2000.0 arcseconds of offset. */
#define LXSmaxpt 4000
#define LXSmaxpt_pro 400
struct LXSstructure {
  int num;                 /* number of total spectra (LXS[0].num only) */
  int id;                  /* ID of a spectrum. */
  float dat[LXSmaxpt];     /* flux values (photons per second per pixel) */
  int num_pro;             /* number of profile data points. */
  float pro[LXSmaxpt_pro]; /* profile data */
};
typedef struct LXSstructure LXStype;



/* Mosaic of concatenated image strips. */
struct MOSstructure {
  int numfile;            /* MOS[0].numfile: # of PRI files to show.   */
  int display_root;       /* Current file# (or root#) to display.      */
  char root[200];         /* Root for filenames.                       */
  char ext[20];           /* Extenstion for filenames (def: 'pri').    */
  char colorfile[80];     /* Color map file for image display.         */
  char prifile[200];      /* -pri.fits image strip FITS filename.      */
  char gspfile[200];      /* -gsp.fits filename.                       */
  char xspfile[200];      /* -xsp.fits filename.                       */
  int gspflag;            /* Does a -gsp.fits file exist?              */
  int xspflag;            /* Does a -xsp.fits file exist?              */
  int spectra_device;     /* Device number for spectra.                */
  int image_device;       /* Device number for image strips.           */
  int showgsp;            /* Flag to show gsp spectra instead of xsp.  */
  int showrsp;            /* Flag to show response image strip.        */
  int histflag;           /* Flag to show histogram-type plotting.     */
  int plane;              /* Current plane number.                     */
  int planesize;          /* Size of each plane in pixels.             */
  int numplane;           /* Total number of planes.                   */
  float bg[3],fg[3];      /* Save the levels for the 3 planes.         */
  int jump;               /* Jumping image strip sets.                 */
  float grspa;            /* Grism PA of initial exposure.             */
  float tottime;          /* total exposure time for image strips.     */
  int totnumexp;          /* total number of exposures.                */
  int numsp;              /* Total number of spectra.                  */
  int numim;              /* Total number of image strips.             */
  int nc;                 /* Total number of columns.                  */
  int nr;                 /* Total number of rows.                     */
  int sr[10],er[10];      /* Row bounds for each image.                */
  float StartPixel;       /* Offset arcseconds of first pixel in strip.*/
  int id[10];             /* Source IDs for each image.                */
  int ss[10];             /* Entry in SL[] array.                      */
  int qq[10];             /* Entry in GSP[] array.                     */
  float tr[6];            /* Translation array.                        */
  float xmin,xmax,ymin,ymax;  /* plot ranges. */
};
typedef struct MOSstructure MOStype;


/* Photon Response Image structure. */
/* Masking [.msk]: 0=no mask, 1=neighbor mask, 2=median mask, 3=both masks.  */
struct PRIstructure {
  int nc;          /* Number of columns in spectral strip.        */
  int nr;          /* Number of rows in spectral strip.           */
  int npix;        /* Number of pixels (nc*nr).                   */
  int id;          /* Source identifier.                          */
  int truthid;     /* Source identifier.                          */
  float objwidth;  /* object width for extraction of this source. */
  float bckwidth;  /* background width for this source.           */
  float arcsec1;   /* offset blue bound.(arcsec)                  */
  float arcsec2;   /* offset red bound.(arcsec)                   */
  float scale;     /* scale in arcsec per pixel                   */
  int bckcolrad;   /* bck column radius (pixels)                  */
  float objbcksep; /* object to background separation (pixels)    */
  double ra;       /* Right Ascension of source.                  */
  double dec;      /* Declination of source.                      */
  float  *pht;     /* Photon data.                         */
  float  *rsp;     /* Response.                            */
  short  *msk;     /* Masking                              */
};
typedef struct PRIstructure PRItype;


/* Reading and writing structure for PRI files. */
#define PRIRWbytes 4
struct PRIRWstructure {
  short int pht;   /* Photons.  */
  short int rsp;   /* Response. */
};
typedef struct PRIRWstructure PRIRWtype;


/* GALEX-SPECTRAL-ACCUMULATION-and-EXTRACTION parameters. */
struct GSAXstructure {

/* special parameters */
  char root[300];     /* root for filenames.                                */
  char suffix[100];   /* put before '.fits' in output files.                */
  char gsaxfile[300]; /* GSAX full filename.                                */
  char phofile[300];  /* photon data filename.                              */
  char aspfile[300];  /* aspect data filename.                              */
  int  phofnum;       /* number of photon filenames.                        */
  char phomore[20][200]; /* more photon data filenames, "phofnum-1" files.  */
  char scstfile[300]; /* State file full filename.                          */
  char rrfile[300];   /* Condensed response image full filename.            */
  char rrhrfile[300]; /* Response image full filename.                      */
  char sprrfile[300]; /* Spectral response cube full filename.              */
  char soufile[300];  /* Source list full filename.                         */
  char offsoufile[300];  /* Source list for use in offset solution only.    */
  char usoufile[MAXusoufile][300];  /* Additional sources file.             */
  int  num_usoufile;  /* Number of usoufile (user source files).            */
  char aspdate[100];  /* Unix file date of aspect file (-asprta.fits).      */
  char stg1date[100]; /* Date of stage 1 reduction (-gsax_rtastar.fits).    */
  char mcatdate[100]; /* Date of source list file (-mcat.fits).             */
  int  mcatsize;      /* Size of source list file in bytes (-mcat.fits).    */
  char gsaxdate[100]; /* Date of creation of parameter file (-gsax.fits).   */
  char prifile[300];  /* Multi-source -pri.fits full filename.              */
  char Cal_Dir[300];  /* Calibration directory.                             */
  char OffsetFile[300]; /* The -gsax.fits file to take offset values from.  */
  char LXSfile[300];  /* Last eXtracted Spectra file (-xsp.fits) from last  */
                      /*   iteration. Use this for neighbor subtraction.    */

/* general image information. */
  char object[200];   /* Object or field name.                              */
  char obsdatim[40];  /* Observation date and time (UT).                    */
  char obsdate[40];   /* Observation date (UT) ( OBS-DATE )                 */
  char timeobs[40];   /* Observation time (UT) ( TIME-OBS )                 */
  double obssecs;     /* Observation time in seconds (unix time).           */
  double expstart;    /* Exposure start time (unix time seconds).           */
  double expend;      /* Exposure end time (unix time seconds).             */
  int eclipse;        /* Eclipse number.                                    */
  int visit;          /* Visit number.                                      */
  int subvisit;       /* Sub-visit number.                                  */
  int tilenum;        /* Tile number.                                       */
  char tilename[200]; /* Tile name.                                         */
  double fdttdc;      /* FDTTDC from -rr.fits file. */

/* general parameters and statistics */
  double exptime;     /* Current exposure time.                             */
  double tottime;     /* Total time of all accumulated exposures.           */
  double MaskPar1;    /* First Masking parameter (used by galexspac).       */
  double MaskPar2;    /* Second Masking parameter (used by spacadd).        */
  double MaskPar3;    /* Third Masking parameter (used by spacadd).         */
  double SubtPar;     /* Subtraction parameter.                             */
  double ra_cent;     /* RA (planned) center for current field.             */
  double dec_cent;    /* DEC (planned) center for current field.            */
  double roll;        /* ROLL angle (planned) for current field.            */
  double avaspra;     /* Average Aspect RA origin for current field.        */
  double avaspdec;    /* Average Aspect DEC origin for current field.       */
  double avasprol;    /* Average Aspect ROLL angle for current field.       */
  double nomfwhm;     /* Nominal (or default) full-width-half-max.          */
  double profwhm;     /* Profile model full-width-half-max.                 */
  double flxfrac;     /* Flux fraction of profile model to be extracted.    */
  double grspa;       /* Determined grism position angle.                   */
  double grspaorg;    /* Original (photon file) grism position angle.       */
  double FieldRadius; /* Field radius in degrees.                           */
  int    Snumber;     /* Number of bright stars used for the final offset.  */
  float  Sxoff;       /* Determined X source position offset in arcseconds. */
  float  Syoff;       /* Determined Y source position offset in arcseconds. */
  float  Stwist;      /* Determined twist for source positions.             */
  float  Sxorms;      /* Sxoff RMS from final offset solution.              */
  float  Syorms;      /* Syoff RMS from final offset solution.              */
  float  Stwres;      /* Stwist median residual (final offset solution).    */
  float  Stures;      /* Stwist median unweighted residual (final solution).*/
  int    Sgood;       /* Number of good stars (weighted) used in final offset solution. */
  float  Sxoitrms;    /* Sxoff iteration RMS (final offset solution).       */
  float  Syoitrms;    /* Syoff iteration RMS (final offset solution).       */
  float  Stwitrms;    /* Stwist iteration RMS (final offset solution).      */
  float  Smdnres;     /* Median residual in arcsec (final offset solution). */
  float  Smdnfwhm;    /* Median FWHM of bright stars in offset solution.    */
  float  Smdnbkdf;    /* Median background difference ratio of bright stars */
  float  peak2mdn;    /* Peak divided by median in 2-D search grid.         */
  int    srchiter;    /* Initial coarse search iterations (finding offset). */
  float  full_residual; /* Full offset residual (in arcseconds).            */

  double gs_dra;      /* Delta RA from galexspac after offset solution.           */
  double gs_ddec;     /* Delta Declination from galexspac after offset solution.  */
  double gs_twist;    /* Delta twist angle from galexspac after offset solution.  */

  float  DIFgrspa;    /* Difference relative to _rtastar of grism position angle.       */
  float  DIFxoff;     /* Difference relative to _rtastar of X offset in arcseconds.     */
  float  DIFyoff;     /* Difference relative to _rtastar of Y offset in arcseconds.     */
  float  DIFtwist;    /* Difference relative to _rtastar of twist.                      */
  float  DIFmdnres;   /* Difference relative to _rtastar of Median residual in arcsec   */
  float  DIFmdnfwhm;  /* Difference relative to _rtastar of Median FWHM of bright stars */
  int    DIFnumber;   /* Difference relative to _rtastar of Number of bright stars used */
  int    DIFfail;     /* Difference failure flag (1=fail,0=ok).                         */

  float  xoa_nuv1;    /* X offset adjustment for nuv order 1 in arcsec.     */
  float  xoa_nuv2;    /* X offset adjustment for nuv order 2 in arcsec.     */
  float  xoa_fuv2;    /* X offset adjustment for fuv order 2 in arcsec.     */
  float  xoa_fuv3;    /* X offset adjustment for fuv order 3 in arcsec.     */
  double radiuscutoff;/* Maximum radius for photons or sources from center. */

  int    median_bck;  /* If "1" median background, rather than average.     */
  int    Clobber;     /* Initialize a new accumulation, delete any previous */
                      /*  -gsax.fits or -pri.fits files.                    */
  char   qadir[200];  /* QA directory to write out verification tables.     */

/* Selection values. */
  int    top;         /* Select only the brightest 'n' sources (extraction) (each band). */
  int    top_mask;    /* Select brightest 'n' sources (possible masking) (each band).    */
  int    select;      /* Select only the brightest 'n' sources (extraction) (both bands).*/
  int    select_mask; /* Select brightest 'n' sources (possible masking) (both bands).   */
  double coadd_exptime; /* Estimated total exposure with all coadds (sec). */
  float  s2n_limit[2];      /* Limit selection to S/N per resolution element (each band) [0]=nuv,[1]=fuv. */
  float  s2n_limit_mask[2]; /* Limit masking selection to S/N per res. elem. (each band) [0]=nuv,[1]=fuv. */
  float extract_flux[2]; /* Smallest N/FUV flux in extracted source list. */
  float extract_s2n[2];  /* Smallest N/FUV S/N per resol. elem. in extracted source list. */
  float mask_flux[2];    /* Smallest N/FUV flux in masked source list. */
  float mask_s2n[2];     /* Smallest N/FUV S/N per resol. elem. in masked source list. */

/* general parameters */
  int totnumexp;      /* Total number of exposures accumulated.             */
  int findoffsets;    /* 1/0: Find X,Y,PA offsets from spectral photon list.*/
  int bandnumber;     /* Current band number (1=NUV, 2=FUV).                */
  int AccumBoxType;   /* Accumulation strip box type (0=full,1=abridged).   */
  int RespOne;        /* Set all response function values to 1.0            */
  int RespWaveOne;    /* Set wavelength response function values to 1.0     */
  int varextr;        /* Use variable extraction parameters (width,length). */
  float nominal_objwidth; /* Nominal object width (extraction window).     */
  int max_sicol;      /* Maximum number of columns allocated in spectral strip. */
  int max_sirow;      /* Maximum number of rows allocated in spectral strip. */
  int max_sipix;      /* Maximum number of pixels allocated (sicol * sirow) */

/* other */
  int ClearGrismFlat; /* If '1' set grism flats to 1.0.                     */
  float nuv_CuJ;      /* NUV conversion from pho/sec to micro Janskys.      */
  float fuv_CuJ;      /* FUV conversion from pho/sec to micro Janskys.      */
  float R2;           /* Radius 2 (arcsec) for nuv_nc/f_r2 columns.         */
  int FileType;       /* Current photon list file type (1,3,4?).            */
  int actnumpho;      /* Actual number of photons (without masked photons)  */
  int entnumpho;      /* Entire number of photons in current photon file.   */
  int totnumpho;      /* Total number of photons (limited read).            */
  int NumSource;      /* Number of sources.                                 */
  int Ecount;         /* Number of sources to be extracted.                 */
  int SUBcount;       /* Subset of sources to be extracted.                 */
  double RadRad;      /* Square of radius from field center (radians sq'ed) */

/* extra */
  double tzero[6];    /* Offsets for current photon file (type 4 only).     */
  double tscal[6];    /* Scalings for current photon file (type 4 only).    */
  float effexp;       /* Average effective exposure (response) (seconds).   */
  float effmsk;       /* Average effective masking fraction.                */
  float effwgt;       /* Average effective weight with masking (sec).       */
  int bsid[MaxBSID];  /* Bright source ID list (from offset finding, for QA)*/
  int ntrange;        /* Time range parameter. */
  double trange[2];   /* Time range boundaries. */
  int DeltaOnly;        /* If '1' then doing -DeltaOnly aspect calculation. */
  double raw6_exptime;  /* Estimate of exposure time from RAW6 photon list. */
};
typedef struct GSAXstructure GSAXtype;


/* Format of simplemap aspect file record. */
struct ASPECTstructure {
  double t;              /* Time stamp, sec.s since 0z 1-1-2000 */
  double Zx,Zy,Zz;       /* Position of instrument z-axis (the boresite) */
  double raz,decz;
  double twistz;         /* Deg. east of north about the z axis */
  double twistzr;        /* In radians */
  double Yx,Yy,Yz;       /* Position of instrument y-axis (sun axis) */
  double ray,decy;
  double twistx;         /* Deg. east of north about the x axis */
  double twistxr ;       /* In radians */
  double xdot,ydot,zdot; /* Rotation rates (rad/sec) */
  unsigned int flags;    /* Control flags */
  unsigned int spare1;
  double spare2;
};
typedef struct ASPECTstructure ASPECTtype;


/* Limits for RAW6 translation onto RA,DEC (prime) coordinates. */
struct LIM6structure {
  double x1,x2;       /* X limits */
  double y1,y2;       /* Y limits */
};
typedef struct LIM6structure LIM6type;



/* Gaussian Area Array structure. */
/* Stores the area of a (half) gaussian as a function of x (0.0 to 5.0). */
struct GAAstructure {
  int nn;          /* number of points. */
  float xx[510];   /* x values. */
  float aa[510];   /* area values. */
};
typedef struct GAAstructure GAAtype;



/* Format of synthetic spectra (flux versus offset in arcseconds).          */
/* The flux values are a function of offset from -5000 to +5000 arcseconds, */
/* where ff[0] is at -5000.0 and ff[10000] is at +5000.0                    */
/* The flux values are divided (normalized) by the flux in imaging mode.    */
struct SYNstructure {
  int num;           /* number of synthetic spectra.       */
  int np;            /* number of points in a spectrum.    */
  int band;          /* band number                        */
  float teff;        /* Effective Temperature in Kelvin.   */
                     /* ".teff" may be spectral template number: 0,1,.... */
  float ff[10010];   /* flux values in photons/arcsecond.  */
};
typedef struct SYNstructure SYNtype;


/* IPAC Table Column information (for a single column). */
struct ITCstructure {
  int ncol;       /* Number of columns: ITC[0].ncol .          */
  char name[30];  /* Column name.                              */
  int b1;         /* First boundary position.  (1=first character of a line) */
  int b2;         /* Second boundary position. (1=first character of a line) */
  char type;      /* Type of value in this column.             */
};
typedef struct ITCstructure ITCtype;


/* Colormap structure. */
struct CLMstructure {
  int num;      /* Number of points: CLM[0].num .        */
  short red;    /* Red value (0-255).                    */
  short green;  /* Green value (0-255).                  */
  short blue;   /* Blue value (0-255).                   */
};
typedef struct CLMstructure CLMtype;

/* Profile data structure. */
#define MaxNumProfile 200
struct Profilestructure {
  int num;             /* Number of profiles: Profile[0].num. */
  int ss;              /* Entry number in SL[].               */
  float fluxmin;       /* Minimum flux: Profile[0].fluxmin .  */
  float cenrow;        /* Center row (or index) number.       */
  float centroid;      /* Computed centroid.                  */
  float fwhm;          /* Computed rough fwhm.                */
  float yy[PMODmax];   /* flux value at spatial point.        */
};
typedef struct Profilestructure Profiletype;


/* Manual QA info. */
struct MQAstructure {
  char Grade[10];
  char Coadd[10];
  char AnalystID[40];
  char Flags[200];
  char CommentFlags[200];
  char Comments[500];
  int  subvisit_count;
  int  pass_count;
  int  fail_count;
  int  unkn_count;
  int  yes_count;
  int  no_count;
};
typedef struct MQAstructure MQAtype;

