/* . . . . . . BEGIN . . . . . . . . . . . . */
extern void simu_load_SYN_temperatures( SYNtype SYN[], char Cal_Dir[] );

extern int simu_compute_objtype( float nuv, float fuv );

extern int simu_deduce_sources( char gsaxfile[], GSAXtype GSAX, int *max_USL );

extern void simu_grabroot( char root[] );

extern void simu_effective_projected_FWHM( GSAXtype GSAX, SLtype SSL, int mode,
                                    float *fwhm_spat, float *fwhm_disp );

extern double simu_count_rate_nuv( double rate, double Teff, int gord );

extern double simu_count_rate_fuv( double rate, double Teff, int gord );

extern double simu_teff_from_ratio( double ratio );

extern void simu_write_MOEA_cfitsio( char tblfile[], char moeafile[], int bandnumber );

extern void simu_write_MOEA_cfitsio_2column( char tblfile[], char moeafile[], int bandnumber );

extern void simu_write_DSP_cfitsio( char outfile[], DSPtype DSP[] );

extern void simu_load_DSP_cfitsio( int bandnumber, DSPtype DSP[], char Cal_Dir[] );

extern void simu_load_DSP_tbl( int bandnumber, DSPtype DSP[], char Cal_Dir[] );

extern void simu_position_of_grism_offset_from_source( double ra, double dec, double offset, GSAXtype GSAX,
                                                RMtype RM, double RotMat[2][2], double TwistMat[2][2],
                                                double *uncor_ra, double *uncor_dec, double *det_x,  double *det_y, double *off_ra, double *off_dec );

extern void simu_uncorrect_radec( double ra, double dec, double RAo, double DECo, double Sxoff, double Syoff,
                           double Stwist, double grspa, double *uncor_ra, double *uncor_dec );

extern void simu_correct_radec( double ra, double dec, double RAo, double DECo, double Sxoff, double Syoff,
                         double Stwist, double grspa, double *new_ra, double *new_dec );

extern void simu_correct_gnomonic( double gpx, double gpy, double Sxoff, double Syoff, double Stwist,
                            double grspa, double *cor_gpx, double *cor_gpy );

extern void simu_add_gsax_cards( fitsfile *fptr, GSAXtype GSAX, char prefix[], int quiet );

extern void simu_start_PRI_cfitsio( fitsfile *fptr_PRI, GSAXtype GSAX, ACEXtype ACEX[], int quiet );

extern void simu_write_PRI_cfitsio( SLtype SSL, PRItype PRI, int next_hdu, fitsfile *fptr_PRI, GSAXtype GSAX );

extern int simu_read_PRI_cfitsio( int next_hdu, fitsfile *fptr_PRI, int bin, PRItype PRI[], int maxpix, GSAXtype GSAX[] );

extern int simu_WhatFileType( char header[], int headersize );

extern int simu_WhatFileType_cfitsio( fitsfile *fptr );

extern void simu_clear_source_list( SLtype SL[], int num );

extern void simu_clear_gsax_data( GSAXtype GSAX[] );

extern void simu_fix_gsax_data( GSAXtype GSAX[] );

extern void simu_read_LXSfile( GSAXtype GSAX, SLtype SL[], LXStype LXS[] );

extern void simu_set_GSAX_stuff( char header[], int headersize, GSAXtype GSAX[] );

extern void simu_read_FITS_header_cfitsio( char file[], int mode, char header[], int headersize );

extern void simu_CleanPhoHead( char header[], int headersize );

extern void simu_SetBothMatrices( IOPtype IOP, RMtype RM[] );

extern double simu_FracFluxGaussian( double row, double crow, double hwhm );

extern int simu_NormalizePSF( int nn, double psf[] );

extern double simu_dispersion_offset( double wave, int oen );

extern void simu_modify_SYN( int bandnumber, SYNtype SYN[] );

extern int simu_MOEA_which_order( double ww, MOEAtype MOEA[], double rannum );

extern void simu_assign_MOEA_filename( int bandnumber, char moeafile[], char Cal_Dir[] );

extern void simu_load_MOEA_cfitsio( int bandnumber, MOEAtype MOEA[], int toddsim, char Cal_Dir[] );

extern int simu_FindSource( double ra, double dec, int *ss, double *sep, SLtype SL[] );

extern void simu_ReadMagConv( char magfile[], MCtype MC[] );

extern double simu_MagConv( double Vmag, double Teff, MCtype MC[] );

extern void simu_ApplyDispersion( DSPtype DSP[], double PA, double lambda, int order,
                           double *cx, double *cy);

extern void simu_ApplyRadialDistortion(int RDn, double RDr[], double RDx[],
                                 double *cx, double *cy);

extern void simu_load_predicted_s2n( float exptime, float nuvback, float fuvback,
                              SLtype SL[] );

extern void simu_OffsetSourcePosition( double Sxoff, double Syoff, RMtype RM, double TwistMat[2][2],
                                double old_ra, double old_dec,
                                double *new_ra, double *new_dec, double *dx, double *dy );

extern void simu_Reverse_OffsetSourcePosition( double Sxoff, double Syoff, RMtype RM, double TwistMatInv[2][2],
                                        double new_ra, double new_dec, double *rest_ra, double *rest_dec );

extern void simu_load_source_col_row_offset_adjustment( GSAXtype GSAX,
                      RMtype RM, double TwistMat[2][2], SLtype SL[] );

extern void simu_load_source_col_row( GSAXtype GSAX, SLtype SL[] );

extern void simu_load_source_flux_s2n( GSAXtype GSAX, SLtype SL[] );

extern void simu_ClipSourceList( SLtype SL[], int clipflag1, int clipflag2 );

extern void simu_clear_SXSL( SXSLtype SXSL[], int nn );

extern int simu_Write_SXSL( fitsfile *fptr, long frow, long nelem,
                      SXSL_INFOtype SXSL_INFO[], int SXSL_blank_entry,
                      SXSLtype SXSL[], int colstart, int naper, int nfolr,
                      short aa_s[], long aa_l[], float aa_f[], double aa_d[] );

extern int simu_Load_SXSL_from_Sextractor_table( char SourceFile[], int max_SXSL, char prefix[],
                                          SXSLtype SXSL[], int *naper, int *nfolr );

extern void simu_SourceList_FindFluxCutoff( char SourceFile[], int top, float *FluxCutoff );

extern float simu_div_99( float value, float sf );

extern void simu_RSL_fix_IDs( SLtype SL[] );

extern void simu_ReadSourceList( char SourceFile[], int bandnumber, double exptime,
                          float FluxCutoff, double RadiusCutoff, float S2N_Cutoff, int quiet,
                          double *ra_cent, double *dec_cent, double *avaspra, double *avaspdec,
                          int max_SL, SLtype SL[] );

extern void simu_ReadMatchList( char MatchFile[], MSLtype MSL[] );

extern void simu_echo_gsax_data( GSAXtype GSAX, ACEXtype ACEX[] );

extern void simu_load_gsax_data( char PRIdir[], GSAXtype uGSAX, GSAXtype GSAX[], SLtype SL[], int max_SL, int quiet,
                          ACEXtype ACEX[], PMODtype PMOD[], int loadonly, int limit_numpho );

extern void simu_write_gsax_data( GSAXtype GSAX, SLtype SL[], ACEXtype ACEX[], PMODtype PMOD, int quiet );

extern void simu_galex_spiral(double t, double *dx, double *dy );

extern int simu_GetOffset( int oo, double *offset, DSPtype DSP[], double wave );

extern int simu_GetWave( int oo, double offset, DSPtype DSP[], double *wave );

extern double simu_ChooseWavelength( double offset, DSPtype DSP[], int *gord );

extern void simu_read_synfile( char synfile[], int bin, int np,
                        double ww[], double ff[] );

extern void simu_Dwarf_File( double Teff, char Cal_Dir[], char dwarffile[] );

extern void simu_read_STD( char Cal_Dir[], int iSTD, int np_syn,
                    double ww_syn[], double ff_syn[] );

extern void simu_Combine_Orders(int nn, double xx[], double ff[], double vv[],
                         DSPtype DSP[], double pessimism, MOEAtype MOEA[], int ngord, int gord[],
                         double exptime, double zero, double disp, int npt,
                         double fwav[], double flux[], double ferr[],
                         int verbose, int NoClip );

extern void simu_CreateSyntheticSpectrum(
       double Teff, char synfile[], double Vmag, double user_nuvimflux,
       double user_fuvimflux, double exptime, char Cal_Dir[],  double pessimism,
       MOEAtype MOEA[], MOEAtype MOEA_NUVIM[], MOEAtype MOEA_FUVIM[],
       DSPtype DSP[], int wrcorr, int norder, int orders[], int np,
       double xx[], double ff[], double smooth_fwhm,
       double *nuvimflux, double *fuvimflux, int verbose );

extern void simu_synthetic_error( char synfile[], double exptime,
                           MOEAtype MOEA_NUV[], MOEAtype MOEA_FUV[],
                           MOEAtype MOEA_NUVIM[], MOEAtype MOEA_FUVIM[],
                           DSPtype DSP_NUV[], DSPtype DSP_FUV[],
                           double zero, double disp, int npt,
                           float waves[], float flux[], float ferr[],
                           float flux_us[], float ferr_us[],
                           int verbose );

extern void simu_WriteSourceList( char soufile[], SLtype SL[], double minflux );

extern void simu_LoadFluxDist( GSAXtype GSAX, SLtype SL[] );

extern int simu_FindSourceNum( int SourceID, SLtype SL[] );

extern int simu_WriteData(FILE *phofu, int phonum, char phohead[],
         double RAorigin, double DECorigin, phofp pholist[], int mode );

extern void simu_Set_RWPN( int bandnumber, DSPtype DSP[], int RWPN[] );

extern void simu_SetRF( char rrhrfile[], GSAXtype GSAX, double RespScale,
                 int RespSide, double RespMin, GFLATtype GFLAT[],
                 IOPtype RFIOP[], float RespFunc[] );

extern void simu_SetRW( char sprrfile[], GSAXtype GSAX, double RespScale,
             int RespSide, double RespMin, double ClipRadius, IOPtype RWIOP[],
             float RespWave[] );

extern float simu_GetRF( IOPtype RFIOP, float RespFunc[], int icol, int irow );

extern void simu_InitWholeFieldWaveResp(DSPtype DSP[], MOEAtype MOEA[], float WFWR[]);

extern float simu_GetWholeFieldWaveResp( double offset, float WFWR[] );

extern float simu_GetCube( IOPtype RWIOP, float RespWave[], double offset,
                    int RWPN[], int icol, int irow );

extern float simu_GetRW( IOPtype RFIOP, float RespFunc[],
                  IOPtype RWIOP, float RespWave[],
                  double offset, float WFWR[], int RWPN[],
                  int icol, int irow, int mode );

extern double simu_primesep( double x1, double y1, double x2, double y2 );

extern void simu_Load_PSF_Profile( int numpro, float pro[], SLtype SSL,
                            double centpsf, int NSIy, double PSF_frac[] );

extern void simu_Find_Masking_Limit_1( float MaskPar, SYNtype SYN[], SLtype SSL,
                GSAXtype GSAX, PRItype PRI, double objcol, double objrow,
                double backrate, float fmin,
                double flux[], double var[], float *MaskLimit );

extern void simu_Find_Masking_Limit_0( SYNtype SYN[], SLtype SSL, float rsp[],
                                int nc_si, double objcol, float fmin, double flux[] );

extern void simu_setsubmask( int ss, SLtype SL[], IOPtype SubIOP, RMtype RM,
            SYNtype SYN[], GSAXtype GSAX, GAAtype GAA, float fmin, PRItype PRI[] );

extern void simu_comptest( int np, float ww[], float imx[], float ee[], float idx[],
  float syn[], float bb[], float cc[], double stats[], double apecorr, int ID,
  double TotNumPA );

extern void simu_SL_flux_qcksrt(int nn, SLtype SL[] );

extern void simu_WFPL_qcksrt(int nn, WFPLtype WFPL[] );

extern int simu_WholeFieldPhoList( GSAXtype GSAX, RMtype RM, WFPL_PARtype WFPL_PAR, int mode, WFPLtype WFPL[], WFPLFtype WFPLF[] );

extern void simu_set_variable_object_width( SLtype SSL[], int bi );

extern void simu_extraction_ranges( SLtype SSL, int maxrow, int *obj1, int *obj2,
                             int *bck00, int *bck01, int *bck10, int *bck11 );

extern void simu_grism_offset_to_detector( int bandnumber, RMtype RM, double RotMat[2][2], double sinang, double cosang, double grspa,
                                    double sra, double sdec, double offset, double *det_x, double *det_y );

extern void simu_grism_detector_positions( int bandnumber, double sra, double sdec, double avaspra, double avaspdec, double avasprol, double grspa,
                                    double *det_x, double *det_y, double *det_mid_x, double *det_mid_y, double *flat_mid_x, double *flat_mid_y );

extern void simu_color_flat_curve( IOPtype SubIOP, RMtype RM, int ss, SLtype SL[], GSAXtype GSAX, double RotMat[2][2], GFLATtype GFLAT[], double sm_rsrc[] );

extern void simu_RSPL_accum_PRI( IOPtype SubIOP, RMtype RM, IOPtype RFIOP,
                          float RespFunc[], IOPtype RWIOP, float RespWave[],
                          float pht[], short msk[], int ss, SLtype SL[],
                          int RWPN[], SYNtype SYN[], GSAXtype GSAX,
                          double RotMat[2][2], double RotMatInv[2][2],
                          GAAtype GAA, float fmin, int next_hdu, fitsfile *fptr_PRI,
                          Profiletype Profile[], GFLATtype GFLAT[] );

extern float simu_masking_minimum_flux( SLtype SL[] );

extern void simu_RSPL_checkcard( char card[], char header[], int headersize );

extern void simu_WFPL_to_subimage( WFPLtype WFPL[], int numpho,
                            int WFPL_index[], int WFPL_MaxInt,
                            double WFPL_Zero, double WFPL_Scale,
                            IOPtype IOP, RMtype RM, float pht[], int ipht[],
                            int WFPL_iix[], int WFPL_iiy[], int count );

extern void simu_create_wfi( WFPLtype WFPL[], int numpho, IOPtype IOP, RMtype RM,
                      double WFPL_Zero, double WFPL_Scale, int WFPL_MaxInt,
                      int WFPL_index[], float image[] );

extern int simu_CreateProfileModel( GSAXtype GSAX, Profiletype Profile[], SLtype SL[], float faint_cutoff, PMODtype PMOD[] );

extern void simu_RunSpecPhoList( WFPLtype WFPL[], WFPL_PARtype WFPL_PAR,
                          GSAXtype GSAX, ACEXtype ACEX[], PMODtype PMOD[], SLtype SL[], LXStype LXS[],
                          SYNtype SYN[], int RWPN[] );

extern void SER( char wrd[] );

extern void simu_Load_Synthetic_Spectra( int bandnumber, MOEAtype MOEA[],
                                  DSPtype DSP[], double smooth_fwhm,
                                  SYNtype SYN[], char Cal_Dir[] );

/* . . . . . . END . . . . . . . . . . . . . */
